
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32A
;Program type             : Application
;Clock frequency          : 8.000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : long, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;Global 'const' stored in FLASH     : No
;Enhanced function parameter passing: Yes
;Enhanced core instructions         : On
;Smart register allocation          : On
;Automatic register allocation      : On

	#pragma AVRPART ADMIN PART_NAME ATmega32A
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2143
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x085F
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _time_cs=R5
	.DEF _time_s=R6

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer1_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x33:
	.DB  0x50
_0x34:
	.DB  0xB0,0x4
_0x35:
	.DB  0xA
_0x8A:
	.DB  0x11,0x22,0x33,0x44,0x55,0x66
_0x8B:
	.DB  0xC0,0xA8,0x2,0xA
_0x8D:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0
_0xB1:
	.DB  0x0,0x0,0x0
_0x0:
	.DB  0x55,0x54,0x50,0x20,0x69,0x73,0x20,0x57
	.DB  0x6F,0x72,0x6B,0x69,0x6E,0x67,0x20,0xA
	.DB  0x0,0x47,0x45,0x54,0x20,0x2F,0x0,0x47
	.DB  0x45,0x54,0x20,0x2F,0x3F,0x6C,0x31,0x3D
	.DB  0x31,0x0,0x47,0x45,0x54,0x20,0x2F,0x3F
	.DB  0x6C,0x31,0x3D,0x30,0x0,0x47,0x45,0x54
	.DB  0x20,0x2F,0x3F,0x52,0x31,0x3D,0x31,0x0
	.DB  0x47,0x45,0x54,0x20,0x2F,0x3F,0x52,0x31
	.DB  0x3D,0x30,0x0,0x47,0x45,0x54,0x20,0x2F
	.DB  0x3F,0x52,0x32,0x3D,0x31,0x0,0x47,0x45
	.DB  0x54,0x20,0x2F,0x3F,0x52,0x32,0x3D,0x30
	.DB  0x0,0x48,0x54,0x54,0x50,0x2F,0x31,0x2E
	.DB  0x30,0x20,0x32,0x30,0x30,0x20,0x4F,0x4B
	.DB  0xD,0xA,0x0,0x43,0x6F,0x6E,0x74,0x65
	.DB  0x6E,0x74,0x2D,0x54,0x79,0x70,0x65,0x3A
	.DB  0x20,0x74,0x65,0x78,0x74,0x2F,0x68,0x74
	.DB  0x6D,0x6C,0xD,0xA,0x0,0x50,0x72,0x61
	.DB  0x67,0x6D,0x61,0x3A,0x20,0x6E,0x6F,0x2D
	.DB  0x63,0x61,0x63,0x68,0x65,0xD,0xA,0xD
	.DB  0xA,0x0,0x3C,0x48,0x54,0x4D,0x4C,0x3E
	.DB  0x3C,0x45,0x74,0x68,0x65,0x72,0x6E,0x65
	.DB  0x74,0x20,0x52,0x65,0x6C,0x61,0x79,0x20
	.DB  0x43,0x6F,0x6E,0x74,0x72,0x6F,0x6C,0x6C
	.DB  0x65,0x72,0x20,0x32,0x43,0x68,0x20,0x20
	.DB  0x3C,0x2F,0x54,0x49,0x54,0x4C,0x45,0x3E
	.DB  0x3C,0x42,0x4F,0x44,0x59,0x3E,0x3C,0x43
	.DB  0x45,0x4E,0x54,0x45,0x52,0x3E,0x0,0x3C
	.DB  0x50,0x3E,0x20,0x4D,0x65,0x6C,0x65,0x63
	.DB  0x2E,0x69,0x72,0x20,0x20,0x3C,0x2F,0x50
	.DB  0x3E,0xA,0x3C,0x48,0x52,0x3E,0x0,0x3C
	.DB  0x50,0x3E,0x20,0x3C,0x46,0x4F,0x4E,0x54
	.DB  0x20,0x43,0x4F,0x4C,0x4F,0x52,0x3D,0x23
	.DB  0x30,0x30,0x30,0x30,0x46,0x46,0x3E,0x20
	.DB  0x0,0x3C,0x50,0x3E,0x20,0x3C,0x46,0x4F
	.DB  0x4E,0x54,0x20,0x43,0x4F,0x4C,0x4F,0x52
	.DB  0x3D,0x23,0x34,0x34,0x61,0x64,0x33,0x39
	.DB  0x3E,0x4C,0x45,0x44,0x3D,0x4F,0x4E,0x3C
	.DB  0x2F,0x46,0x4F,0x4E,0x54,0x3E,0x3C,0x2F
	.DB  0x50,0x3E,0x0,0x3C,0x41,0x20,0x48,0x52
	.DB  0x45,0x46,0x3D,0x22,0x2E,0x2F,0x3F,0x6C
	.DB  0x31,0x3D,0x30,0x22,0x3E,0x54,0x75,0x72
	.DB  0x6E,0x20,0x4F,0x46,0x46,0x20,0x4C,0x45
	.DB  0x44,0x3C,0x2F,0x41,0x3E,0x0,0x3C,0x50
	.DB  0x3E,0x20,0x3C,0x46,0x4F,0x4E,0x54,0x20
	.DB  0x43,0x4F,0x4C,0x4F,0x52,0x3D,0x23,0x34
	.DB  0x34,0x61,0x64,0x33,0x39,0x3E,0x4C,0x45
	.DB  0x44,0x3D,0x4F,0x46,0x46,0x3C,0x2F,0x46
	.DB  0x4F,0x4E,0x54,0x3E,0x3C,0x2F,0x50,0x3E
	.DB  0x0,0x3C,0x41,0x20,0x48,0x52,0x45,0x46
	.DB  0x3D,0x22,0x2E,0x2F,0x3F,0x6C,0x31,0x3D
	.DB  0x31,0x22,0x3E,0x54,0x75,0x72,0x6E,0x20
	.DB  0x4F,0x4E,0x20,0x4C,0x45,0x44,0x3C,0x2F
	.DB  0x41,0x3E,0x0,0x3C,0x48,0x52,0x3E,0x3C
	.DB  0x2F,0x46,0x4F,0x4E,0x54,0x3E,0x3C,0x2F
	.DB  0x50,0x3E,0x0,0x3C,0x50,0x3E,0x0,0x3C
	.DB  0x50,0x3E,0x20,0x3C,0x46,0x4F,0x4E,0x54
	.DB  0x20,0x43,0x4F,0x4C,0x4F,0x52,0x3D,0x23
	.DB  0x34,0x34,0x61,0x64,0x33,0x39,0x3E,0x52
	.DB  0x65,0x6C,0x61,0x79,0x31,0x3D,0x4F,0x4E
	.DB  0x3C,0x2F,0x46,0x4F,0x4E,0x54,0x3E,0x3C
	.DB  0x2F,0x50,0x3E,0x0,0x3C,0x41,0x20,0x48
	.DB  0x52,0x45,0x46,0x3D,0x22,0x2E,0x2F,0x3F
	.DB  0x52,0x31,0x3D,0x30,0x22,0x3E,0x54,0x75
	.DB  0x72,0x6E,0x20,0x4F,0x46,0x46,0x20,0x52
	.DB  0x65,0x6C,0x61,0x79,0x31,0x3C,0x2F,0x41
	.DB  0x3E,0x0,0x3C,0x50,0x3E,0x20,0x3C,0x46
	.DB  0x4F,0x4E,0x54,0x20,0x43,0x4F,0x4C,0x4F
	.DB  0x52,0x3D,0x23,0x34,0x34,0x61,0x64,0x33
	.DB  0x39,0x3E,0x52,0x65,0x6C,0x61,0x79,0x31
	.DB  0x3D,0x4F,0x46,0x46,0x3C,0x2F,0x46,0x4F
	.DB  0x4E,0x54,0x3E,0x3C,0x2F,0x50,0x3E,0x0
	.DB  0x3C,0x41,0x20,0x48,0x52,0x45,0x46,0x3D
	.DB  0x22,0x2E,0x2F,0x3F,0x52,0x31,0x3D,0x31
	.DB  0x22,0x3E,0x54,0x75,0x72,0x6E,0x20,0x4F
	.DB  0x4E,0x20,0x52,0x65,0x6C,0x61,0x79,0x31
	.DB  0x3C,0x2F,0x41,0x3E,0x0,0x3C,0x50,0x3E
	.DB  0x20,0x3C,0x46,0x4F,0x4E,0x54,0x20,0x43
	.DB  0x4F,0x4C,0x4F,0x52,0x3D,0x23,0x34,0x34
	.DB  0x61,0x64,0x33,0x39,0x3E,0x52,0x65,0x6C
	.DB  0x61,0x79,0x32,0x3D,0x4F,0x4E,0x3C,0x2F
	.DB  0x46,0x4F,0x4E,0x54,0x3E,0x3C,0x2F,0x50
	.DB  0x3E,0x0,0x3C,0x41,0x20,0x48,0x52,0x45
	.DB  0x46,0x3D,0x22,0x2E,0x2F,0x3F,0x52,0x32
	.DB  0x3D,0x30,0x22,0x3E,0x54,0x75,0x72,0x6E
	.DB  0x20,0x4F,0x46,0x46,0x20,0x52,0x65,0x6C
	.DB  0x61,0x79,0x32,0x3C,0x2F,0x41,0x3E,0x0
	.DB  0x3C,0x50,0x3E,0x20,0x3C,0x46,0x4F,0x4E
	.DB  0x54,0x20,0x43,0x4F,0x4C,0x4F,0x52,0x3D
	.DB  0x23,0x34,0x34,0x61,0x64,0x33,0x39,0x3E
	.DB  0x52,0x65,0x6C,0x61,0x79,0x32,0x3D,0x4F
	.DB  0x46,0x46,0x3C,0x2F,0x46,0x4F,0x4E,0x54
	.DB  0x3E,0x3C,0x2F,0x50,0x3E,0x0,0x3C,0x41
	.DB  0x20,0x48,0x52,0x45,0x46,0x3D,0x22,0x2E
	.DB  0x2F,0x3F,0x52,0x32,0x3D,0x31,0x22,0x3E
	.DB  0x54,0x75,0x72,0x6E,0x20,0x4F,0x4E,0x20
	.DB  0x52,0x65,0x6C,0x61,0x79,0x32,0x3C,0x2F
	.DB  0x41,0x3E,0x0,0x3C,0x48,0x52,0x3E,0x20
	.DB  0x3C,0x2F,0x46,0x4F,0x4E,0x54,0x3E,0x3C
	.DB  0x2F,0x50,0x3E,0x0,0x3C,0x50,0x3E,0x3C
	.DB  0x41,0x20,0x48,0x52,0x45,0x46,0x3D,0x22
	.DB  0x2E,0x22,0x3E,0x72,0x65,0x66,0x72,0x65
	.DB  0x73,0x68,0x3C,0x2F,0x41,0x3E,0x3C,0x2F
	.DB  0x50,0x3E,0x3C,0x2F,0x43,0x45,0x4E,0x54
	.DB  0x45,0x52,0x3E,0x3C,0x48,0x52,0x3E,0xA
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x01
	.DW  _wwwport_G000
	.DW  _0x33*2

	.DW  0x02
	.DW  _udpport_G000
	.DW  _0x34*2

	.DW  0x01
	.DW  _seqnum_G000
	.DW  _0x35*2

	.DW  0x06
	.DW  _mymac
	.DW  _0x8A*2

	.DW  0x04
	.DW  _myip
	.DW  _0x8B*2

	.DW  0x2A
	.DW  _0xA6
	.DW  _0x0*2+265

	.DW  0x2B
	.DW  _0xA6+42
	.DW  _0x0*2+342

	.DW  0x2D
	.DW  _0xA6+85
	.DW  _0x0*2+439

	.DW  0x2E
	.DW  _0xA6+130
	.DW  _0x0*2+522

	.DW  0x2D
	.DW  _0xA6+176
	.DW  _0x0*2+605

	.DW  0x2E
	.DW  _0xA6+221
	.DW  _0x0*2+688

	.DW  0x03
	.DW  0x05
	.DW  _0xB1*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;#include <mega32a.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <stdio.h>
;#include <string.h>
;#include <delay.h>
;
;//--------------------------------------
;#define ENC28J60_SPI_PORT       PORTB
;#define ENC28J60_SPI_DDR        DDRB
;#define ENC28J60_SPI_MISO       6
;#define ENC28J60_SPI_MOSI       5
;#define ENC28J60_SPI_SCK        7
;#define ENC28J60_SPI_CS         4
;// ethernet buffer size
;#define BUFFER_SIZE             1024
;#include "ethernet.h"

	.CSEG
_enc28j60ReadOp:
	ST   -Y,R26
;	op -> Y+1
;	address -> Y+0
	CBI  0x18,4
	LD   R30,Y
	ANDI R30,LOW(0x1F)
	LDD  R26,Y+1
	OR   R30,R26
	OUT  0xF,R30
_0x3:
	SBIS 0xE,7
	RJMP _0x3
	LDI  R30,LOW(0)
	OUT  0xF,R30
_0x6:
	SBIS 0xE,7
	RJMP _0x6
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x9
	LDI  R30,LOW(0)
	OUT  0xF,R30
_0xA:
	SBIS 0xE,7
	RJMP _0xA
_0x9:
	SBI  0x18,4
	IN   R30,0xF
	RJMP _0x206000B
_enc28j60WriteOp:
	ST   -Y,R26
;	op -> Y+2
;	address -> Y+1
;	data -> Y+0
	CBI  0x18,4
	LDD  R30,Y+1
	ANDI R30,LOW(0x1F)
	LDD  R26,Y+2
	OR   R30,R26
	OUT  0xF,R30
_0xD:
	SBIS 0xE,7
	RJMP _0xD
	LD   R30,Y
	OUT  0xF,R30
_0x10:
	SBIS 0xE,7
	RJMP _0x10
	SBI  0x18,4
	RJMP _0x206000D
_enc28j60ReadBuffer:
	ST   -Y,R27
	ST   -Y,R26
;	len -> Y+2
;	*data -> Y+0
	CBI  0x18,4
	LDI  R30,LOW(58)
	OUT  0xF,R30
_0x13:
	SBIS 0xE,7
	RJMP _0x13
_0x16:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,0
	BREQ _0x18
	SBIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	LDI  R30,LOW(0)
	OUT  0xF,R30
_0x19:
	SBIS 0xE,7
	RJMP _0x19
	IN   R30,0xF
	LD   R26,Y
	LDD  R27,Y+1
	ST   X,R30
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
	RJMP _0x16
_0x18:
	LD   R26,Y
	LDD  R27,Y+1
	LDI  R30,LOW(0)
	ST   X,R30
	SBI  0x18,4
	RJMP _0x2060007
_enc28j60WriteBuffer:
	ST   -Y,R27
	ST   -Y,R26
;	len -> Y+2
;	*data -> Y+0
	CBI  0x18,4
	LDI  R30,LOW(122)
	OUT  0xF,R30
_0x1C:
	SBIS 0xE,7
	RJMP _0x1C
_0x1F:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,0
	BREQ _0x21
	SBIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	LD   R26,Y
	LDD  R27,Y+1
	LD   R30,X
	OUT  0xF,R30
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
_0x22:
	SBIS 0xE,7
	RJMP _0x22
	RJMP _0x1F
_0x21:
	SBI  0x18,4
	RJMP _0x2060007
_enc28j60SetBank:
	ST   -Y,R26
;	address -> Y+0
	LD   R30,Y
	ANDI R30,LOW(0x60)
	MOV  R26,R30
	LDS  R30,_Enc28j60Bank_G000
	CP   R30,R26
	BREQ _0x25
	LDI  R30,LOW(160)
	ST   -Y,R30
	LDI  R30,LOW(31)
	ST   -Y,R30
	LDI  R26,LOW(3)
	CALL SUBOPT_0x0
	LDD  R30,Y+2
	ANDI R30,LOW(0x60)
	LDI  R31,0
	ASR  R31
	ROR  R30
	CALL __ASRW4
	MOV  R26,R30
	RCALL _enc28j60WriteOp
	LD   R30,Y
	ANDI R30,LOW(0x60)
	STS  _Enc28j60Bank_G000,R30
_0x25:
	RJMP _0x2060011
_enc28j60Read:
	ST   -Y,R26
;	address -> Y+0
	LD   R26,Y
	RCALL _enc28j60SetBank
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDD  R26,Y+1
	RCALL _enc28j60ReadOp
_0x2060011:
	ADIW R28,1
	RET
;	address -> Y+0
_enc28j60Write:
	ST   -Y,R26
;	address -> Y+1
;	data -> Y+0
	LDD  R26,Y+1
	RCALL _enc28j60SetBank
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R26,Y+2
	RCALL _enc28j60WriteOp
	RJMP _0x206000B
_enc28j60PhyWrite:
	ST   -Y,R27
	ST   -Y,R26
;	address -> Y+2
;	data -> Y+0
	LDI  R30,LOW(212)
	ST   -Y,R30
	LDD  R26,Y+3
	RCALL _enc28j60Write
	LDI  R30,LOW(214)
	ST   -Y,R30
	LDD  R26,Y+1
	RCALL _enc28j60Write
	LDI  R30,LOW(215)
	ST   -Y,R30
	LDD  R26,Y+2
	RCALL _enc28j60Write
_0x29:
	LDI  R26,LOW(234)
	RCALL _enc28j60Read
	ANDI R30,LOW(0x1)
	BREQ _0x2B
	__DELAY_USB 40
	RJMP _0x29
_0x2B:
	RJMP _0x206000D
;	clk -> Y+0
_enc28j60Init:
	ST   -Y,R27
	ST   -Y,R26
;	*macaddr -> Y+0
	CBI  0x17,6
	IN   R30,0x17
	ORI  R30,LOW(0xB0)
	OUT  0x17,R30
	IN   R30,0x18
	ANDI R30,LOW(0x5F)
	OUT  0x18,R30
	SBI  0x18,4
	LDI  R30,LOW(80)
	OUT  0xD,R30
	SBI  0xE,0
	LDI  R30,LOW(255)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(255)
	RCALL _enc28j60WriteOp
	LDI  R26,LOW(50)
	CALL SUBOPT_0x1
	LDI  R30,LOW(0)
	STS  _NextPacketPtr_G000,R30
	STS  _NextPacketPtr_G000+1,R30
	LDI  R30,LOW(8)
	CALL SUBOPT_0x2
	LDI  R30,LOW(9)
	CALL SUBOPT_0x2
	LDI  R30,LOW(12)
	CALL SUBOPT_0x2
	LDI  R30,LOW(13)
	CALL SUBOPT_0x2
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R26,LOW(254)
	RCALL _enc28j60Write
	LDI  R30,LOW(11)
	CALL SUBOPT_0x3
	LDI  R30,LOW(4)
	CALL SUBOPT_0x4
	LDI  R30,LOW(5)
	CALL SUBOPT_0x3
	LDI  R30,LOW(6)
	CALL SUBOPT_0x4
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R26,LOW(31)
	RCALL _enc28j60Write
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R26,LOW(176)
	RCALL _enc28j60Write
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R26,LOW(63)
	RCALL _enc28j60Write
	LDI  R30,LOW(41)
	ST   -Y,R30
	LDI  R26,LOW(48)
	RCALL _enc28j60Write
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R26,LOW(249)
	RCALL _enc28j60Write
	LDI  R30,LOW(49)
	ST   -Y,R30
	LDI  R26,LOW(247)
	RCALL _enc28j60Write
	LDI  R30,LOW(192)
	ST   -Y,R30
	LDI  R26,LOW(13)
	RCALL _enc28j60Write
	LDI  R30,LOW(193)
	CALL SUBOPT_0x2
	LDI  R30,LOW(128)
	ST   -Y,R30
	LDI  R30,LOW(194)
	ST   -Y,R30
	LDI  R26,LOW(50)
	RCALL _enc28j60WriteOp
	LDI  R30,LOW(198)
	ST   -Y,R30
	LDI  R26,LOW(18)
	RCALL _enc28j60Write
	LDI  R30,LOW(199)
	ST   -Y,R30
	LDI  R26,LOW(12)
	RCALL _enc28j60Write
	LDI  R30,LOW(196)
	ST   -Y,R30
	LDI  R26,LOW(18)
	RCALL _enc28j60Write
	LDI  R30,LOW(202)
	ST   -Y,R30
	LDI  R26,LOW(220)
	RCALL _enc28j60Write
	LDI  R30,LOW(203)
	ST   -Y,R30
	LDI  R26,LOW(5)
	RCALL _enc28j60Write
	LDI  R30,LOW(228)
	ST   -Y,R30
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R26,X
	RCALL _enc28j60Write
	LDI  R30,LOW(229)
	ST   -Y,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDD  R26,Z+1
	RCALL _enc28j60Write
	LDI  R30,LOW(226)
	ST   -Y,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDD  R26,Z+2
	RCALL _enc28j60Write
	LDI  R30,LOW(227)
	ST   -Y,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDD  R26,Z+3
	RCALL _enc28j60Write
	LDI  R30,LOW(224)
	ST   -Y,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDD  R26,Z+4
	RCALL _enc28j60Write
	LDI  R30,LOW(225)
	ST   -Y,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDD  R26,Z+5
	RCALL _enc28j60Write
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R26,LOW(256)
	LDI  R27,HIGH(256)
	RCALL _enc28j60PhyWrite
	LDI  R26,LOW(31)
	RCALL _enc28j60SetBank
	LDI  R30,LOW(128)
	ST   -Y,R30
	LDI  R30,LOW(27)
	ST   -Y,R30
	LDI  R26,LOW(192)
	CALL SUBOPT_0x0
	LDI  R26,LOW(4)
	RCALL _enc28j60WriteOp
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R26,LOW(1142)
	LDI  R27,HIGH(1142)
	RCALL _enc28j60PhyWrite
	LDI  R26,LOW(20)
	CALL SUBOPT_0x1
	RJMP _0x206000B
_enc28j60PacketSend:
	ST   -Y,R27
	ST   -Y,R26
;	len -> Y+2
;	*packet -> Y+0
	LDI  R30,LOW(2)
	CALL SUBOPT_0x4
	LDI  R30,LOW(3)
	CALL SUBOPT_0x3
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDD  R26,Y+3
	SUBI R26,-LOW(255)
	RCALL _enc28j60Write
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	SUBI R26,LOW(-6655)
	SBCI R27,HIGH(-6655)
	MOVW R30,R26
	MOV  R30,R31
	LDI  R31,0
	MOV  R26,R30
	RCALL _enc28j60Write
	LDI  R30,LOW(122)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _enc28j60WriteOp
	CALL SUBOPT_0x5
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL _enc28j60WriteBuffer
	LDI  R30,LOW(128)
	CALL SUBOPT_0x6
	LDI  R26,LOW(28)
	RCALL _enc28j60Read
	ANDI R30,LOW(0x2)
	BREQ _0x2E
	LDI  R30,LOW(160)
	CALL SUBOPT_0x6
_0x2E:
	RJMP _0x2060007
_enc28j60PacketReceive:
	ST   -Y,R27
	ST   -Y,R26
	CALL __SAVELOCR4
;	maxlen -> Y+6
;	*packet -> Y+4
;	rxstat -> R16,R17
;	len -> R18,R19
	LDI  R26,LOW(57)
	RCALL _enc28j60Read
	CPI  R30,0
	BRNE _0x2F
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __LOADLOCR4
	RJMP _0x206000E
_0x2F:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R26,_NextPacketPtr_G000
	RCALL _enc28j60Write
	LDI  R30,LOW(1)
	CALL SUBOPT_0x7
	CALL SUBOPT_0x8
	LDI  R31,0
	CALL SUBOPT_0x9
	MOV  R31,R30
	LDI  R30,0
	LDS  R26,_NextPacketPtr_G000
	LDS  R27,_NextPacketPtr_G000+1
	OR   R30,R26
	OR   R31,R27
	CALL SUBOPT_0x9
	MOV  R18,R30
	CLR  R19
	CALL SUBOPT_0x8
	MOV  R31,R30
	LDI  R30,0
	__ORWRR 18,19,30,31
	__SUBWRN 18,19,4
	CALL SUBOPT_0x8
	MOV  R16,R30
	CLR  R17
	CALL SUBOPT_0x8
	MOV  R31,R30
	LDI  R30,0
	__ORWRR 16,17,30,31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SBIW R30,1
	CP   R30,R18
	CPC  R31,R19
	BRSH _0x30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SBIW R30,1
	MOVW R18,R30
_0x30:
	SBRC R16,7
	RJMP _0x31
	__GETWRN 18,19,0
	RJMP _0x32
_0x31:
	ST   -Y,R19
	ST   -Y,R18
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL _enc28j60ReadBuffer
_0x32:
	LDI  R30,LOW(12)
	ST   -Y,R30
	LDS  R26,_NextPacketPtr_G000
	RCALL _enc28j60Write
	LDI  R30,LOW(13)
	CALL SUBOPT_0x7
	LDI  R30,LOW(128)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	LDI  R26,LOW(64)
	RCALL _enc28j60WriteOp
	MOVW R30,R18
	CALL __LOADLOCR4
	RJMP _0x206000E

	.DSEG

	.CSEG
_checksum:
	ST   -Y,R26
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
;	*buf -> Y+7
;	len -> Y+5
;	type -> Y+4
;	sum -> Y+0
	LDD  R26,Y+4
	CPI  R26,LOW(0x1)
	BRNE _0x36
	CALL SUBOPT_0xA
	__ADDD1N 17
	CALL SUBOPT_0xB
	CALL SUBOPT_0xC
_0x36:
	LDD  R26,Y+4
	CPI  R26,LOW(0x2)
	BRNE _0x37
	CALL SUBOPT_0xA
	__ADDD1N 6
	CALL SUBOPT_0xB
	CALL SUBOPT_0xC
_0x37:
_0x38:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,2
	BRLO _0x3A
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	LD   R30,X
	LDI  R31,0
	CALL __CWD1
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(8)
	CALL __LSLD12
	MOVW R26,R30
	MOVW R24,R22
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	LDD  R30,Z+1
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __ORD12
	__ANDD1N 0xFFFF
	CALL SUBOPT_0xD
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ADIW R30,2
	STD  Y+7,R30
	STD  Y+7+1,R31
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	SBIW R30,2
	STD  Y+5,R30
	STD  Y+5+1,R31
	RJMP _0x38
_0x3A:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	SBIW R30,0
	BREQ _0x3B
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(8)
	CALL __LSLD12
	CALL SUBOPT_0xD
_0x3B:
_0x3C:
	CALL SUBOPT_0xA
	CALL __LSRD16
	CALL __CPD10
	BREQ _0x3E
	CALL SUBOPT_0xA
	__ANDD1N 0xFFFF
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0xA
	CALL __LSRD16
	CALL __ADDD12
	CALL SUBOPT_0xB
	RJMP _0x3C
_0x3E:
	LD   R26,Y
	LDD  R27,Y+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	EOR  R30,R26
	EOR  R31,R27
	RJMP _0x2060005
_eth_type_is_arp_and_my_ip:
	CALL SUBOPT_0xE
;	*buf -> Y+3
;	len -> Y+1
;	i -> R17
	SBIW R26,41
	BRLO _0x206000F
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ADIW R26,12
	LD   R26,X
	CPI  R26,LOW(0x8)
	BRNE _0x41
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ADIW R26,13
	LD   R26,X
	CPI  R26,LOW(0x6)
	BREQ _0x40
_0x41:
	RJMP _0x206000F
_0x40:
_0x43:
	CPI  R17,4
	BRSH _0x45
	CALL SUBOPT_0xF
	ADIW R30,38
	CALL SUBOPT_0x10
	BRNE _0x206000F
	SUBI R17,-1
	RJMP _0x43
_0x45:
	LDI  R30,LOW(1)
	RJMP _0x2060010
_eth_type_is_ip_and_my_ip:
	CALL SUBOPT_0xE
;	*buf -> Y+3
;	len -> Y+1
;	i -> R17
	SBIW R26,42
	BRLO _0x206000F
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ADIW R26,12
	LD   R26,X
	CPI  R26,LOW(0x8)
	BRNE _0x49
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ADIW R26,13
	LD   R26,X
	CPI  R26,LOW(0x0)
	BREQ _0x48
_0x49:
	RJMP _0x206000F
_0x48:
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ADIW R26,14
	LD   R26,X
	CPI  R26,LOW(0x45)
	BREQ _0x4B
_0x206000F:
	LDI  R30,LOW(0)
_0x2060010:
	LDD  R17,Y+0
	ADIW R28,5
	RET
_0x4B:
_0x4C:
	CPI  R17,4
	BRSH _0x4E
	CALL SUBOPT_0xF
	ADIW R30,30
	CALL SUBOPT_0x10
	BREQ _0x4F
	LDI  R30,LOW(0)
	LDD  R17,Y+0
	JMP  _0x2060002
_0x4F:
	SUBI R17,-1
	RJMP _0x4C
_0x4E:
	LDI  R30,LOW(1)
	LDD  R17,Y+0
	JMP  _0x2060002
_make_eth:
	CALL SUBOPT_0x11
;	*buf -> Y+1
;	i -> R17
_0x50:
	CPI  R17,6
	BRSH _0x52
	CALL SUBOPT_0x12
	ADIW R30,0
	CALL SUBOPT_0x13
	ADIW R30,6
	CALL SUBOPT_0x14
	CALL SUBOPT_0x15
	ADIW R30,6
	CALL SUBOPT_0x14
	CALL SUBOPT_0x16
	RJMP _0x50
_0x52:
	RJMP _0x206000C
_fill_ip_hdr_checksum:
	CALL SUBOPT_0x17
;	*buf -> Y+2
;	ck -> R16,R17
	ADIW R26,24
	CALL SUBOPT_0x18
	ADIW R26,25
	CALL SUBOPT_0x18
	ADIW R26,20
	LDI  R30,LOW(64)
	ST   X,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,21
	CALL SUBOPT_0x18
	ADIW R26,22
	LDI  R30,LOW(64)
	ST   X,R30
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,14
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL SUBOPT_0x19
	__PUTB1SNS 2,24
	MOV  R30,R16
	__PUTB1SNS 2,25
	RJMP _0x2060008
_make_ip:
	CALL SUBOPT_0x11
;	*buf -> Y+1
;	i -> R17
_0x53:
	CPI  R17,4
	BRSH _0x55
	CALL SUBOPT_0x12
	ADIW R30,30
	CALL SUBOPT_0x13
	ADIW R30,26
	CALL SUBOPT_0x14
	CALL SUBOPT_0x15
	ADIW R30,26
	CALL SUBOPT_0x14
	CALL SUBOPT_0x1A
	RJMP _0x53
_0x55:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	RCALL _fill_ip_hdr_checksum
	RJMP _0x206000C
_make_tcphead:
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
;	*buf -> Y+6
;	rel_ack_num -> Y+4
;	mss -> Y+3
;	cp_seq -> Y+2
;	i -> R17
;	tseq -> R16
	LDI  R17,0
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R30,Z+34
	__PUTB1SNS 6,36
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R30,Z+35
	__PUTB1SNS 6,37
	LDS  R30,_wwwport_G000
	__PUTB1SNS 6,35
	LDS  R30,_wwwport_G000+1
	__PUTB1SNS 6,34
	LDI  R17,LOW(4)
_0x56:
	CPI  R17,1
	BRLO _0x58
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1C
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	LDI  R31,0
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+4,R30
	STD  Y+4+1,R31
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1D
	LD   R16,X
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1D
	LDD  R30,Y+4
	ST   X,R30
	LDD  R30,Y+2
	CPI  R30,0
	BREQ _0x59
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1C
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R16
	RJMP _0x5A
_0x59:
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1C
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
_0x5A:
	LDD  R30,Y+5
	ANDI R31,HIGH(0x0)
	STD  Y+4,R30
	STD  Y+4+1,R31
	SUBI R17,1
	RJMP _0x56
_0x58:
	LDD  R30,Y+2
	CPI  R30,0
	BRNE _0x5B
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,38
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,39
	ST   X,R30
	LDS  R30,_seqnum_G000
	__PUTB1SNS 6,40
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,41
	LDI  R30,LOW(0)
	ST   X,R30
	LDS  R30,_seqnum_G000
	SUBI R30,-LOW(2)
	STS  _seqnum_G000,R30
_0x5B:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,50
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,51
	ST   X,R30
	LDD  R30,Y+3
	CPI  R30,0
	BREQ _0x5C
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,54
	LDI  R30,LOW(2)
	ST   X,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,55
	LDI  R30,LOW(4)
	ST   X,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,56
	LDI  R30,LOW(5)
	ST   X,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,57
	LDI  R30,LOW(128)
	ST   X,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,46
	LDI  R30,LOW(96)
	RJMP _0xAC
_0x5C:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,46
	LDI  R30,LOW(80)
_0xAC:
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x206000E:
	ADIW R28,8
	RET
_make_arp_answer_from_request:
	CALL SUBOPT_0xE
;	*buf -> Y+1
;	i -> R17
	RCALL _make_eth
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,20
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,21
	LDI  R30,LOW(2)
	ST   X,R30
_0x5E:
	CPI  R17,6
	BRSH _0x60
	CALL SUBOPT_0x12
	ADIW R30,32
	CALL SUBOPT_0x13
	ADIW R30,22
	CALL SUBOPT_0x14
	CALL SUBOPT_0x15
	ADIW R30,22
	CALL SUBOPT_0x14
	CALL SUBOPT_0x16
	RJMP _0x5E
_0x60:
	LDI  R17,LOW(0)
_0x61:
	CPI  R17,4
	BRSH _0x63
	CALL SUBOPT_0x12
	ADIW R30,38
	CALL SUBOPT_0x13
	ADIW R30,28
	CALL SUBOPT_0x14
	CALL SUBOPT_0x15
	ADIW R30,28
	CALL SUBOPT_0x14
	CALL SUBOPT_0x1A
	RJMP _0x61
_0x63:
	LDI  R30,LOW(42)
	LDI  R31,HIGH(42)
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	RCALL _enc28j60PacketSend
_0x206000C:
	LDD  R17,Y+0
_0x206000D:
	ADIW R28,3
	RET
_make_echo_reply_from_request:
	ST   -Y,R27
	ST   -Y,R26
;	*buf -> Y+2
;	len -> Y+0
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL SUBOPT_0x1E
	RCALL _make_ip
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,34
	CALL SUBOPT_0x18
	ADIW R26,36
	LD   R26,X
	CPI  R26,LOW(0xF8)
	BRLO _0x64
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,37
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
_0x64:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,36
	LD   R30,X
	SUBI R30,-LOW(8)
	ST   X,R30
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL _enc28j60PacketSend
	RJMP _0x2060007
_make_udp_reply_from_request:
	ST   -Y,R26
	CALL __SAVELOCR4
;	*buf -> Y+5
;	datalen -> Y+4
;	i -> R17
;	ck -> R18,R19
	LDI  R17,0
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	RCALL _make_eth
	LDD  R26,Y+4
	CPI  R26,LOW(0xDD)
	BRLO _0x65
	LDI  R30,LOW(220)
	STD  Y+4,R30
_0x65:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	ADIW R26,16
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R30,Y+4
	SUBI R30,-LOW(28)
	__PUTB1SNS 5,17
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	RCALL _make_ip
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LDD  R30,Z+34
	__PUTB1SNS 5,36
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LDD  R30,Z+35
	__PUTB1SNS 5,37
	LDS  R30,_udpport_G000+1
	__PUTB1SNS 5,34
	LDS  R30,_udpport_G000
	__PUTB1SNS 5,35
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	ADIW R26,38
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R30,Y+4
	SUBI R30,-LOW(8)
	__PUTB1SNS 5,39
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	ADIW R26,40
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	ADIW R26,41
	ST   X,R30
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+6
	LDI  R31,0
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(1)
	RCALL _checksum
	MOVW R18,R30
	MOV  R30,R19
	__PUTB1SNS 5,40
	MOV  R30,R18
	__PUTB1SNS 5,41
	LDD  R30,Y+4
	LDI  R31,0
	ADIW R30,42
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	RCALL _enc28j60PacketSend
	CALL __LOADLOCR4
	RJMP _0x206000A
_make_tcp_synack_from_syn:
	CALL SUBOPT_0x17
;	*buf -> Y+2
;	ck -> R16,R17
	CALL SUBOPT_0x1E
	ADIW R26,16
	CALL SUBOPT_0x18
	ADIW R26,17
	LDI  R30,LOW(44)
	ST   X,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL _make_ip
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,47
	LDI  R30,LOW(18)
	ST   X,R30
	CALL SUBOPT_0x5
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _make_tcphead
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x20
	LDI  R30,LOW(58)
	LDI  R31,HIGH(58)
	RJMP _0x2060006
_get_tcp_data_pointer:
	ST   -Y,R27
	ST   -Y,R26
;	*buf -> Y+0
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R30,Z+16
	MOV  R31,R30
	LDI  R30,0
	MOVW R26,R30
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R30,Z+17
	LDI  R31,0
	ANDI R31,HIGH(0xFF)
	OR   R30,R26
	OR   R31,R27
	CALL SUBOPT_0x21
	CALL SUBOPT_0x22
	SBIW R30,20
	CALL SUBOPT_0x21
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R30,Z+46
	LDI  R31,0
	CALL __ASRW4
	CALL __LSLW2
	STS  _info_hdr_len_G000,R30
	STS  _info_hdr_len_G000+1,R31
	LDS  R26,_info_hdr_len_G000
	LDS  R27,_info_hdr_len_G000+1
	CALL SUBOPT_0x22
	SUB  R30,R26
	SBC  R31,R27
	CALL SUBOPT_0x21
	LDS  R26,_info_data_len_G000
	LDS  R27,_info_data_len_G000+1
	CALL __CPW02
	BRLT _0x66
	LDI  R30,LOW(0)
	STS  _info_data_len_G000,R30
	STS  _info_data_len_G000+1,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RJMP _0x206000B
_0x66:
	LDS  R30,_info_hdr_len_G000
	LDS  R31,_info_hdr_len_G000+1
	ADIW R30,34
_0x206000B:
	ADIW R28,2
	RET
_concatstrf:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
;	*buf -> Y+5
;	pos -> Y+3
;	*s -> Y+1
;	c -> R17
_0x67:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x69
	CALL SUBOPT_0x23
	RJMP _0x67
_0x69:
	RJMP _0x2060009
_concatstr:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
;	*buf -> Y+5
;	pos -> Y+3
;	*s -> Y+1
;	c -> R17
_0x6A:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x6C
	CALL SUBOPT_0x23
	RJMP _0x6A
_0x6C:
_0x2060009:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	LDD  R17,Y+0
_0x206000A:
	ADIW R28,7
	RET
_make_tcp_ack_from_any:
	CALL SUBOPT_0x17
;	*buf -> Y+2
;	j -> R16,R17
	CALL SUBOPT_0x1E
	ADIW R26,47
	LDI  R30,LOW(16)
	ST   X,R30
	CALL SUBOPT_0x22
	SBIW R30,0
	BRNE _0x6D
	CALL SUBOPT_0x5
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0xAD
_0x6D:
	CALL SUBOPT_0x5
	CALL SUBOPT_0x22
_0xAD:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	RCALL _make_tcphead
	__GETWRN 16,17,40
	MOV  R30,R17
	__PUTB1SNS 2,16
	MOV  R30,R16
	__PUTB1SNS 2,17
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL _make_ip
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x20
	LDI  R30,LOW(54)
	LDI  R31,HIGH(54)
_0x2060006:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL _enc28j60PacketSend
_0x2060008:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x2060007:
	ADIW R28,4
	RET
_make_tcp_ack_with_data:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
;	*buf -> Y+4
;	dlen -> Y+2
;	j -> R16,R17
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADIW R26,47
	LDI  R30,LOW(25)
	ST   X,R30
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,40
	MOVW R16,R30
	MOV  R30,R17
	__PUTB1SNS 4,16
	MOV  R30,R16
	__PUTB1SNS 4,17
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL _fill_ip_hdr_checksum
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADIW R26,50
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADIW R26,51
	ST   X,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,28
	CALL SUBOPT_0x1F
	__PUTB1SNS 4,50
	MOV  R30,R16
	__PUTB1SNS 4,51
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,54
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL _enc28j60PacketSend
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x2060004
_ethernet_init:
	CALL SUBOPT_0x11
;	*dev_mac -> Y+7
;	*dev_ip -> Y+5
;	port_tcp -> Y+3
;	port_udp -> Y+1
;	i -> R17
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	STS  _wwwport_G000,R30
	STS  _wwwport_G000+1,R31
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	STS  _udpport_G000,R30
	STS  _udpport_G000+1,R31
_0x6F:
	CPI  R17,4
	BRSH _0x71
	CALL SUBOPT_0x1B
	SUBI R30,LOW(-_ipaddr_G000)
	SBCI R31,HIGH(-_ipaddr_G000)
	MOVW R0,R30
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	CALL SUBOPT_0x24
	RJMP _0x6F
_0x71:
	LDI  R17,LOW(0)
_0x72:
	CPI  R17,6
	BRSH _0x74
	CALL SUBOPT_0x1B
	SUBI R30,LOW(-_macaddr_G000)
	SBCI R31,HIGH(-_macaddr_G000)
	MOVW R0,R30
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	CALL SUBOPT_0x24
	RJMP _0x72
_0x74:
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	RCALL _enc28j60Init
	LDD  R17,Y+0
_0x2060005:
	ADIW R28,9
	RET
_ethernet_process:
	CALL __SAVELOCR6
;	plen -> R16,R17
;	data_p -> R18,R19
;	data_len -> R21
	LDI  R30,LOW(1024)
	LDI  R31,HIGH(1024)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(_eth_buf)
	LDI  R27,HIGH(_eth_buf)
	RCALL _enc28j60PacketReceive
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BRNE PC+3
	JMP _0x75
	CALL SUBOPT_0x25
	RCALL _eth_type_is_arp_and_my_ip
	CPI  R30,0
	BREQ _0x76
	LDI  R26,LOW(_eth_buf)
	LDI  R27,HIGH(_eth_buf)
	RCALL _make_arp_answer_from_request
	RJMP _0x77
_0x76:
	CALL SUBOPT_0x25
	RCALL _eth_type_is_ip_and_my_ip
	CPI  R30,0
	BRNE PC+3
	JMP _0x78
	__GETB2MN _eth_buf,23
	CPI  R26,LOW(0x1)
	BRNE _0x7A
	__GETB2MN _eth_buf,34
	CPI  R26,LOW(0x8)
	BREQ _0x7B
_0x7A:
	RJMP _0x79
_0x7B:
	CALL SUBOPT_0x25
	RCALL _make_echo_reply_from_request
	RJMP _0x7C
_0x79:
	__GETB2MN _eth_buf,23
	CPI  R26,LOW(0x6)
	BRNE _0x7E
	__GETB2MN _eth_buf,36
	LDS  R30,_wwwport_G000+1
	CALL SUBOPT_0x26
	BRNE _0x7E
	__GETB2MN _eth_buf,37
	LDS  R30,_wwwport_G000
	LDS  R31,_wwwport_G000+1
	CALL SUBOPT_0x27
	BREQ _0x7F
_0x7E:
	RJMP _0x7D
_0x7F:
	__GETB1MN _eth_buf,47
	ANDI R30,LOW(0x2)
	BREQ _0x80
	LDI  R26,LOW(_eth_buf)
	LDI  R27,HIGH(_eth_buf)
	RCALL _make_tcp_synack_from_syn
	RJMP _0x81
_0x80:
	__GETB1MN _eth_buf,47
	ANDI R30,LOW(0x10)
	BREQ _0x82
	LDI  R26,LOW(_eth_buf)
	LDI  R27,HIGH(_eth_buf)
	RCALL _get_tcp_data_pointer
	MOVW R18,R30
	MOV  R0,R18
	OR   R0,R19
	BRNE _0x83
	__GETB1MN _eth_buf,47
	ANDI R30,LOW(0x1)
	BREQ _0x84
	LDI  R26,LOW(_eth_buf)
	LDI  R27,HIGH(_eth_buf)
	RCALL _make_tcp_ack_from_any
_0x84:
	RJMP _0x85
_0x83:
	MOVW R30,R18
	SUBI R30,LOW(-_eth_buf)
	SBCI R31,HIGH(-_eth_buf)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW2MN _eth_buf,54
	RCALL _ethernet_tcp
	MOVW R16,R30
	LDI  R26,LOW(_eth_buf)
	LDI  R27,HIGH(_eth_buf)
	RCALL _make_tcp_ack_from_any
	CALL SUBOPT_0x25
	RCALL _make_tcp_ack_with_data
_0x85:
_0x82:
_0x81:
	RJMP _0x86
_0x7D:
	__GETB2MN _eth_buf,23
	CPI  R26,LOW(0x11)
	BRNE _0x88
	__GETB2MN _eth_buf,36
	LDS  R30,_udpport_G000+1
	CALL SUBOPT_0x26
	BRNE _0x88
	__GETB2MN _eth_buf,37
	LDS  R30,_udpport_G000
	LDS  R31,_udpport_G000+1
	CALL SUBOPT_0x27
	BREQ _0x89
_0x88:
	RJMP _0x87
_0x89:
	__GETB1MN _eth_buf,39
	SUBI R30,LOW(8)
	MOV  R21,R30
	__POINTW1MN _eth_buf,42
	ST   -Y,R31
	ST   -Y,R30
	MOV  R26,R21
	RCALL _ethernet_udp
	MOV  R21,R30
	LDI  R30,LOW(_eth_buf)
	LDI  R31,HIGH(_eth_buf)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R26,R21
	RCALL _make_udp_reply_from_request
_0x87:
_0x86:
_0x7C:
_0x78:
_0x77:
_0x75:
	CALL __LOADLOCR6
_0x2060004:
	ADIW R28,6
	RET
;//--------------------------------------
;#define Relay1 PORTA.0
;#define Relay2 PORTA.1
;#define LED    PORTA.2
;
;
;
;//--------------------------------------
;unsigned char   mymac[6] = {0x11,0x22,0x33,0x44,0x55,0x66};     // MAC

	.DSEG
;unsigned char   myip[4] = {192,168,2,10};                       // IP
;unsigned char   time_cs = 0;            // 1/100 second counter
;unsigned int    time_s = 0;             // seconds counter
;//unsigned int    counter1 = 0;           // button 1 clicks
;//unsigned int    counter2 = 0;           // button 2 clicks
;//--------------------------------------
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)  // Timer 1 overflow ISR
; 0000 0020 {

	.CSEG
_timer1_ovf_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0021 
; 0000 0022         static bit old_btn1 = 0, old_btn2 = 0;
; 0000 0023         if (++time_cs==100)             // one second elapsed
	INC  R5
	LDI  R30,LOW(100)
	CP   R30,R5
	BRNE _0x8C
; 0000 0024         {
; 0000 0025                 time_cs = 0;
	CLR  R5
; 0000 0026                 time_s ++;
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
	SBIW R30,1
; 0000 0027                 #asm("wdr");
	wdr
; 0000 0028         }
; 0000 0029 
; 0000 002A }
_0x8C:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;//--------------------------------------
;void main(void)
; 0000 002D {
_main:
; 0000 002E         uint8_t str[20]="";     // buffer to
; 0000 002F         char t_lcd_buffer_1[10],t_lcd_buffer_2[10];
; 0000 0030    // Watchdog Timer Enabled with Prescaler: OSC/512k
; 0000 0031       WDTCR=0x0D;
	SBIW R28,40
	LDI  R24,20
	LDI  R26,LOW(20)
	LDI  R27,HIGH(20)
	LDI  R30,LOW(_0x8D*2)
	LDI  R31,HIGH(_0x8D*2)
	CALL __INITLOCB
;	str -> Y+20
;	t_lcd_buffer_1 -> Y+10
;	t_lcd_buffer_2 -> Y+0
	LDI  R30,LOW(13)
	OUT  0x21,R30
; 0000 0032 
; 0000 0033         DDRA=(1<<0)|(1<<1)|(1<<2);
	LDI  R30,LOW(7)
	OUT  0x1A,R30
; 0000 0034 
; 0000 0035         // Timer 1 interrupts every 10 ms
; 0000 0036         TCCR1A=0x02;
	LDI  R30,LOW(2)
	OUT  0x2F,R30
; 0000 0037         TCCR1B=0x19;
	LDI  R30,LOW(25)
	OUT  0x2E,R30
; 0000 0038         ICR1H=0xF4;
	LDI  R30,LOW(244)
	OUT  0x27,R30
; 0000 0039         ICR1L=0x23;
	LDI  R30,LOW(35)
	OUT  0x26,R30
; 0000 003A         // Timer(s) Interrupt(s) initialization
; 0000 003B         TIMSK=0x04;
	LDI  R30,LOW(4)
	OUT  0x39,R30
; 0000 003C         // Analog Comparator: Off
; 0000 003D         ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 003E 
; 0000 003F 
; 0000 0040 
; 0000 0041 
; 0000 0042         #asm("wdr");
	wdr
; 0000 0043 
; 0000 0044         // initialize ethernet
; 0000 0045         ethernet_init(mymac, myip, 80, 1200);
	LDI  R30,LOW(_mymac)
	LDI  R31,HIGH(_mymac)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_myip)
	LDI  R31,HIGH(_myip)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(1200)
	LDI  R27,HIGH(1200)
	RCALL _ethernet_init
; 0000 0046 
; 0000 0047 
; 0000 0048 
; 0000 0049         // Global enable interrupts
; 0000 004A         #asm("sei")
	sei
; 0000 004B         #asm("wdr");
	wdr
; 0000 004C 
; 0000 004D 
; 0000 004E         while (1)
_0x8E:
; 0000 004F         {
; 0000 0050                 #asm("wdr");
	wdr
; 0000 0051                ethernet_process(); //process ethernet transactions
	RCALL _ethernet_process
; 0000 0052                delay_ms(100);
	LDI  R26,LOW(100)
	CALL SUBOPT_0x1
; 0000 0053 
; 0000 0054         }
	RJMP _0x8E
; 0000 0055 }
_0x91:
	RJMP _0x91
;//--------------------------------------
;unsigned char ethernet_udp(unsigned char* data, unsigned char data_len)
; 0000 0058 {
_ethernet_udp:
; 0000 0059         unsigned char str[20];
; 0000 005A         strncpy(str, data, 11);
	ST   -Y,R26
	SBIW R28,20
;	*data -> Y+21
;	data_len -> Y+20
;	str -> Y+0
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(11)
	CALL _strncpy
; 0000 005B         sprintf(str, "UTP is Working \n");
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 005C         data_len = concatstr(data, 0, str);
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	CALL SUBOPT_0x28
	MOVW R26,R28
	ADIW R26,4
	RCALL _concatstr
	STD  Y+20,R30
; 0000 005D         time_cs = 0;
	CLR  R5
; 0000 005E         time_s = 0;
	CLR  R6
	CLR  R7
; 0000 005F         return data_len;
	ADIW R28,23
	RET
; 0000 0060 }
;//--------------------------------------
;unsigned int ethernet_tcp(unsigned char* request, unsigned char* response)
; 0000 0063 {
_ethernet_tcp:
; 0000 0064         unsigned int len;
; 0000 0065         unsigned char str[20],ledstatus[43],r1status[46],r2status[46];
; 0000 0066         if (strncmpf(request, "GET /", 5)!=0)
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,63
	SBIW R28,63
	SBIW R28,29
	ST   -Y,R17
	ST   -Y,R16
;	*request -> Y+159
;	*response -> Y+157
;	len -> R16,R17
;	str -> Y+137
;	ledstatus -> Y+94
;	r1status -> Y+48
;	r2status -> Y+2
	CALL SUBOPT_0x29
	__POINTW1FN _0x0,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(5)
	CALL _strncmpf
	CPI  R30,0
	BREQ _0x92
; 0000 0067                 return 0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RJMP _0x2060003
; 0000 0068           // relays if
; 0000 0069 
; 0000 006A 
; 0000 006B           strncpy(str,request,10);
_0x92:
	MOVW R30,R28
	SUBI R30,LOW(-(137))
	SBCI R31,HIGH(-(137))
	ST   -Y,R31
	ST   -Y,R30
	__GETW1SX 161
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(10)
	CALL _strncpy
; 0000 006C           if (strncmpf(request, "GET /?l1=1", 10)==0)
	CALL SUBOPT_0x29
	__POINTW1FN _0x0,23
	CALL SUBOPT_0x2A
	BRNE _0x93
; 0000 006D           {
; 0000 006E            LED=1;
	SBI  0x1B,2
; 0000 006F 
; 0000 0070 
; 0000 0071             }
; 0000 0072            if (strncmpf(request, "GET /?l1=0", 10)==0)
_0x93:
	CALL SUBOPT_0x29
	__POINTW1FN _0x0,34
	CALL SUBOPT_0x2A
	BRNE _0x96
; 0000 0073             {
; 0000 0074            LED=0;
	CBI  0x1B,2
; 0000 0075 
; 0000 0076             }
; 0000 0077 
; 0000 0078           if (strncmpf(request, "GET /?R1=1", 10)==0)
_0x96:
	CALL SUBOPT_0x29
	__POINTW1FN _0x0,45
	CALL SUBOPT_0x2A
	BRNE _0x99
; 0000 0079           {
; 0000 007A            Relay1=1;
	SBI  0x1B,0
; 0000 007B 
; 0000 007C            }
; 0000 007D 
; 0000 007E            if (strncmpf(request, "GET /?R1=0", 10)==0)
_0x99:
	CALL SUBOPT_0x29
	__POINTW1FN _0x0,56
	CALL SUBOPT_0x2A
	BRNE _0x9C
; 0000 007F           {
; 0000 0080            Relay1=0;
	CBI  0x1B,0
; 0000 0081 
; 0000 0082            }
; 0000 0083 
; 0000 0084           if (strncmpf(request, "GET /?R2=1", 10)==0)
_0x9C:
	CALL SUBOPT_0x29
	__POINTW1FN _0x0,67
	CALL SUBOPT_0x2A
	BRNE _0x9F
; 0000 0085            {
; 0000 0086            Relay2=1;
	SBI  0x1B,1
; 0000 0087 
; 0000 0088            }
; 0000 0089            if (strncmpf(request, "GET /?R2=0", 10)==0)
_0x9F:
	CALL SUBOPT_0x29
	__POINTW1FN _0x0,78
	CALL SUBOPT_0x2A
	BRNE _0xA2
; 0000 008A            {
; 0000 008B            Relay2=0;
	CBI  0x1B,1
; 0000 008C 
; 0000 008D            }
; 0000 008E 
; 0000 008F 
; 0000 0090          //end realy
; 0000 0091 
; 0000 0092         len = concatstrf(response, 0, "HTTP/1.0 200 OK\r\n");
_0xA2:
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x28
	__POINTW2FN _0x0,89
	CALL SUBOPT_0x2C
; 0000 0093         len = concatstrf(response, len, "Content-Type: text/html\r\n");
	__POINTW2FN _0x0,107
	CALL SUBOPT_0x2C
; 0000 0094         len = concatstrf(response, len, "Pragma: no-cache\r\n\r\n");
	__POINTW2FN _0x0,133
	CALL SUBOPT_0x2C
; 0000 0095         len = concatstrf(response, len,
; 0000 0096                 "<HTML><Ethernet Relay Controller 2Ch  </TITLE><BODY><CENTER>");
	__POINTW2FN _0x0,154
	CALL SUBOPT_0x2C
; 0000 0097         len = concatstrf(response, len,
; 0000 0098                 "<P> Melec.ir  </P>\n<HR>");
	__POINTW2FN _0x0,215
	CALL SUBOPT_0x2C
; 0000 0099 
; 0000 009A 
; 0000 009B           len = concatstrf(response, len,"<P> <FONT COLOR=#0000FF> ");
	__POINTW2FN _0x0,239
	RCALL _concatstrf
	MOVW R16,R30
; 0000 009C 
; 0000 009D                 if(LED==1){
	SBIS 0x1B,2
	RJMP _0xA5
; 0000 009E            strcpy(ledstatus,"<P> <FONT COLOR=#44ad39>LED=ON</FONT></P>");
	MOVW R30,R28
	SUBI R30,LOW(-(94))
	SBCI R31,HIGH(-(94))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW2MN _0xA6,0
	CALL SUBOPT_0x2D
; 0000 009F            len = concatstrf(response, len,
; 0000 00A0                  "<A HREF=\"./?l1=0\">Turn OFF LED</A>");
	__POINTW2FN _0x0,307
	RJMP _0xAE
; 0000 00A1             }
; 0000 00A2            else{
_0xA5:
; 0000 00A3            strcpy(ledstatus,"<P> <FONT COLOR=#44ad39>LED=OFF</FONT></P>");
	MOVW R30,R28
	SUBI R30,LOW(-(94))
	SBCI R31,HIGH(-(94))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW2MN _0xA6,42
	CALL SUBOPT_0x2D
; 0000 00A4             len = concatstrf(response, len,
; 0000 00A5                 "<A HREF=\"./?l1=1\">Turn ON LED</A>");
	__POINTW2FN _0x0,385
_0xAE:
	RCALL _concatstrf
	MOVW R16,R30
; 0000 00A6             }
; 0000 00A7              len = concatstr(response, len, ledstatus);
	CALL SUBOPT_0x2E
	MOVW R26,R28
	SUBI R26,LOW(-(98))
	SBCI R27,HIGH(-(98))
	CALL SUBOPT_0x2F
; 0000 00A8            len = concatstrf(response, len, "<HR></FONT></P>");
	__POINTW2FN _0x0,419
	CALL SUBOPT_0x2C
; 0000 00A9 
; 0000 00AA 
; 0000 00AB 
; 0000 00AC 
; 0000 00AD 
; 0000 00AE             len = concatstrf(response, len,"<P>");
	__POINTW2FN _0x0,435
	RCALL _concatstrf
	MOVW R16,R30
; 0000 00AF 
; 0000 00B0                   if(Relay1==1) {
	SBIS 0x1B,0
	RJMP _0xA8
; 0000 00B1            strcpy(r1status,"<P> <FONT COLOR=#44ad39>Relay1=ON</FONT></P>");
	MOVW R30,R28
	ADIW R30,48
	ST   -Y,R31
	ST   -Y,R30
	__POINTW2MN _0xA6,85
	CALL SUBOPT_0x2D
; 0000 00B2             len = concatstrf(response, len,
; 0000 00B3                 "<A HREF=\"./?R1=0\">Turn OFF Relay1</A>");
	__POINTW2FN _0x0,484
	RJMP _0xAF
; 0000 00B4             }
; 0000 00B5            else          {
_0xA8:
; 0000 00B6             strcpy(r1status,"<P> <FONT COLOR=#44ad39>Relay1=OFF</FONT></P>");
	MOVW R30,R28
	ADIW R30,48
	ST   -Y,R31
	ST   -Y,R30
	__POINTW2MN _0xA6,130
	CALL SUBOPT_0x2D
; 0000 00B7             len = concatstrf(response, len,
; 0000 00B8                 "<A HREF=\"./?R1=1\">Turn ON Relay1</A>");
	__POINTW2FN _0x0,568
_0xAF:
	RCALL _concatstrf
	MOVW R16,R30
; 0000 00B9                  }
; 0000 00BA                  len = concatstr(response, len, r1status);
	CALL SUBOPT_0x2E
	MOVW R26,R28
	ADIW R26,52
	CALL SUBOPT_0x2F
; 0000 00BB            len = concatstrf(response, len, "<HR>");
	__POINTW2FN _0x0,234
	CALL SUBOPT_0x2C
; 0000 00BC 
; 0000 00BD 
; 0000 00BE 
; 0000 00BF 
; 0000 00C0              len = concatstrf(response, len,"<P> <FONT COLOR=#0000FF> ");
	__POINTW2FN _0x0,239
	RCALL _concatstrf
	MOVW R16,R30
; 0000 00C1 
; 0000 00C2 
; 0000 00C3                  if(Relay2==1)  {
	SBIS 0x1B,1
	RJMP _0xAA
; 0000 00C4              strcpy(r2status,"<P> <FONT COLOR=#44ad39>Relay2=ON</FONT></P>");
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	__POINTW2MN _0xA6,176
	CALL SUBOPT_0x2D
; 0000 00C5                 len = concatstrf(response, len,
; 0000 00C6                 "<A HREF=\"./?R2=0\">Turn OFF Relay2</A>");
	__POINTW2FN _0x0,650
	RJMP _0xB0
; 0000 00C7 
; 0000 00C8              }
; 0000 00C9            else  {
_0xAA:
; 0000 00CA            strcpy(r2status,"<P> <FONT COLOR=#44ad39>Relay2=OFF</FONT></P>");
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	__POINTW2MN _0xA6,221
	CALL SUBOPT_0x2D
; 0000 00CB                len = concatstrf(response, len,
; 0000 00CC                 "<A HREF=\"./?R2=1\">Turn ON Relay2</A>");
	__POINTW2FN _0x0,734
_0xB0:
	RCALL _concatstrf
	MOVW R16,R30
; 0000 00CD 
; 0000 00CE            }
; 0000 00CF             len = concatstr(response, len, r2status);
	CALL SUBOPT_0x2E
	MOVW R26,R28
	ADIW R26,6
	CALL SUBOPT_0x2F
; 0000 00D0            len = concatstrf(response, len, "<HR> </FONT></P>");
	__POINTW2FN _0x0,771
	CALL SUBOPT_0x2C
; 0000 00D1 
; 0000 00D2 //            len = concatstrf(response, len,"<P> <FONT COLOR=#0000FF> ");
; 0000 00D3 //            len = concatstr(response, len, str);
; 0000 00D4 //           len = concatstrf(response, len, "</FONT></P>");
; 0000 00D5 
; 0000 00D6 
; 0000 00D7 
; 0000 00D8 
; 0000 00D9 
; 0000 00DA 
; 0000 00DB 
; 0000 00DC         len = concatstrf(response, len,
; 0000 00DD                 "<P><A HREF=\".\">refresh</A></P></CENTER><HR>\n");
	__POINTW2FN _0x0,788
	RCALL _concatstrf
	MOVW R16,R30
; 0000 00DE 
; 0000 00DF 
; 0000 00E0 
; 0000 00E1 
; 0000 00E2 
; 0000 00E3 
; 0000 00E4 
; 0000 00E5 
; 0000 00E6 
; 0000 00E7 
; 0000 00E8 
; 0000 00E9 
; 0000 00EA         time_cs = 0;
	CLR  R5
; 0000 00EB         time_s = 0;
	CLR  R6
	CLR  R7
; 0000 00EC         return len;
	MOVW R30,R16
_0x2060003:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,63
	ADIW R28,63
	ADIW R28,35
	RET
; 0000 00ED }

	.DSEG
_0xA6:
	.BYTE 0x10B
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G100:
	CALL SUBOPT_0x17
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2000014
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
_0x2000014:
_0x2000013:
	RJMP _0x2000015
_0x2000010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2000015:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x2060002:
	ADIW R28,5
	RET
__print_G100:
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,11
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+17
	LDD  R27,Y+17+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000016:
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	ADIW R30,1
	STD  Y+23,R30
	STD  Y+23+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2000018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001C
	CPI  R18,37
	BRNE _0x200001D
	LDI  R17,LOW(1)
	RJMP _0x200001E
_0x200001D:
	CALL SUBOPT_0x30
_0x200001E:
	RJMP _0x200001B
_0x200001C:
	CPI  R30,LOW(0x1)
	BRNE _0x200001F
	CPI  R18,37
	BRNE _0x2000020
	CALL SUBOPT_0x30
	RJMP _0x20000CF
_0x2000020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000021
	LDI  R16,LOW(1)
	RJMP _0x200001B
_0x2000021:
	CPI  R18,43
	BRNE _0x2000022
	LDI  R20,LOW(43)
	RJMP _0x200001B
_0x2000022:
	CPI  R18,32
	BRNE _0x2000023
	LDI  R20,LOW(32)
	RJMP _0x200001B
_0x2000023:
	RJMP _0x2000024
_0x200001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2000025
_0x2000024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000026
	ORI  R16,LOW(128)
	RJMP _0x200001B
_0x2000026:
	RJMP _0x2000027
_0x2000025:
	CPI  R30,LOW(0x3)
	BRNE _0x2000028
_0x2000027:
	CPI  R18,48
	BRLO _0x200002A
	CPI  R18,58
	BRLO _0x200002B
_0x200002A:
	RJMP _0x2000029
_0x200002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001B
_0x2000029:
	CPI  R18,108
	BRNE _0x200002C
	ORI  R16,LOW(2)
	LDI  R17,LOW(5)
	RJMP _0x200001B
_0x200002C:
	RJMP _0x200002D
_0x2000028:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x200001B
_0x200002D:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x2000032
	CALL SUBOPT_0x31
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x32
	RJMP _0x2000033
_0x2000032:
	CPI  R30,LOW(0x73)
	BRNE _0x2000035
	CALL SUBOPT_0x31
	CALL SUBOPT_0x33
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000036
_0x2000035:
	CPI  R30,LOW(0x70)
	BRNE _0x2000038
	CALL SUBOPT_0x31
	CALL SUBOPT_0x33
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000036:
	ANDI R16,LOW(127)
	LDI  R30,LOW(0)
	STD  Y+16,R30
	LDI  R19,LOW(0)
	RJMP _0x2000039
_0x2000038:
	CPI  R30,LOW(0x64)
	BREQ _0x200003C
	CPI  R30,LOW(0x69)
	BRNE _0x200003D
_0x200003C:
	ORI  R16,LOW(4)
	RJMP _0x200003E
_0x200003D:
	CPI  R30,LOW(0x75)
	BRNE _0x200003F
_0x200003E:
	LDI  R30,LOW(10)
	STD  Y+16,R30
	SBRS R16,1
	RJMP _0x2000040
	__GETD1N 0x3B9ACA00
	CALL SUBOPT_0x34
	LDI  R17,LOW(10)
	RJMP _0x2000041
_0x2000040:
	__GETD1N 0x2710
	CALL SUBOPT_0x34
	LDI  R17,LOW(5)
	RJMP _0x2000041
_0x200003F:
	CPI  R30,LOW(0x58)
	BRNE _0x2000043
	ORI  R16,LOW(8)
	RJMP _0x2000044
_0x2000043:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2000077
_0x2000044:
	LDI  R30,LOW(16)
	STD  Y+16,R30
	SBRS R16,1
	RJMP _0x2000046
	__GETD1N 0x10000000
	CALL SUBOPT_0x34
	LDI  R17,LOW(8)
	RJMP _0x2000041
_0x2000046:
	__GETD1N 0x1000
	CALL SUBOPT_0x34
	LDI  R17,LOW(4)
_0x2000041:
	SBRS R16,1
	RJMP _0x2000047
	CALL SUBOPT_0x31
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	ADIW R26,4
	CALL __GETD1P
	RJMP _0x20000D0
_0x2000047:
	SBRS R16,2
	RJMP _0x2000049
	CALL SUBOPT_0x31
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	ADIW R26,4
	CALL __GETW1P
	CALL __CWD1
	RJMP _0x20000D0
_0x2000049:
	CALL SUBOPT_0x31
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	ADIW R26,4
	CALL __GETW1P
	CLR  R22
	CLR  R23
_0x20000D0:
	__PUTD1S 12
	SBRS R16,2
	RJMP _0x200004B
	LDD  R26,Y+15
	TST  R26
	BRPL _0x200004C
	__GETD1S 12
	CALL __ANEGD1
	__PUTD1S 12
	LDI  R20,LOW(45)
_0x200004C:
	CPI  R20,0
	BREQ _0x200004D
	SUBI R17,-LOW(1)
	RJMP _0x200004E
_0x200004D:
	ANDI R16,LOW(251)
_0x200004E:
_0x200004B:
_0x2000039:
	SBRC R16,0
	RJMP _0x200004F
_0x2000050:
	CP   R17,R21
	BRSH _0x2000052
	SBRS R16,7
	RJMP _0x2000053
	SBRS R16,2
	RJMP _0x2000054
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x2000055
_0x2000054:
	LDI  R18,LOW(48)
_0x2000055:
	RJMP _0x2000056
_0x2000053:
	LDI  R18,LOW(32)
_0x2000056:
	CALL SUBOPT_0x30
	SUBI R21,LOW(1)
	RJMP _0x2000050
_0x2000052:
_0x200004F:
	MOV  R19,R17
	LDD  R30,Y+16
	CPI  R30,0
	BRNE _0x2000057
_0x2000058:
	CPI  R19,0
	BREQ _0x200005A
	SBRS R16,3
	RJMP _0x200005B
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x200005C
_0x200005B:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x200005C:
	CALL SUBOPT_0x30
	CPI  R21,0
	BREQ _0x200005D
	SUBI R21,LOW(1)
_0x200005D:
	SUBI R19,LOW(1)
	RJMP _0x2000058
_0x200005A:
	RJMP _0x200005E
_0x2000057:
_0x2000060:
	CALL SUBOPT_0x35
	CALL __DIVD21U
	MOV  R18,R30
	CPI  R18,10
	BRLO _0x2000062
	SBRS R16,3
	RJMP _0x2000063
	SUBI R18,-LOW(55)
	RJMP _0x2000064
_0x2000063:
	SUBI R18,-LOW(87)
_0x2000064:
	RJMP _0x2000065
_0x2000062:
	SUBI R18,-LOW(48)
_0x2000065:
	SBRC R16,4
	RJMP _0x2000067
	CPI  R18,49
	BRSH _0x2000069
	__GETD2S 8
	__CPD2N 0x1
	BRNE _0x2000068
_0x2000069:
	RJMP _0x200006B
_0x2000068:
	CP   R21,R19
	BRLO _0x200006D
	SBRS R16,0
	RJMP _0x200006E
_0x200006D:
	RJMP _0x200006C
_0x200006E:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x200006F
	LDI  R18,LOW(48)
_0x200006B:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x2000070
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x32
	CPI  R21,0
	BREQ _0x2000071
	SUBI R21,LOW(1)
_0x2000071:
_0x2000070:
_0x200006F:
_0x2000067:
	CALL SUBOPT_0x30
	CPI  R21,0
	BREQ _0x2000072
	SUBI R21,LOW(1)
_0x2000072:
_0x200006C:
	SUBI R19,LOW(1)
	CALL SUBOPT_0x35
	CALL __MODD21U
	__PUTD1S 12
	LDD  R30,Y+16
	__GETD2S 8
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __DIVD21U
	CALL SUBOPT_0x34
	__GETD1S 8
	CALL __CPD10
	BREQ _0x2000061
	RJMP _0x2000060
_0x2000061:
_0x200005E:
	SBRS R16,0
	RJMP _0x2000073
_0x2000074:
	CPI  R21,0
	BREQ _0x2000076
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x32
	RJMP _0x2000074
_0x2000076:
_0x2000073:
_0x2000077:
_0x2000033:
_0x20000CF:
	LDI  R17,LOW(0)
_0x200001B:
	RJMP _0x2000016
_0x2000018:
	LDD  R26,Y+17
	LDD  R27,Y+17+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,25
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	CALL SUBOPT_0x36
	SBIW R30,0
	BRNE _0x2000078
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2060001
_0x2000078:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	CALL SUBOPT_0x36
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __print_G100
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x2060001:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG
_strcpy:
	ST   -Y,R27
	ST   -Y,R26
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpy0:
    ld   r22,z+
    st   x+,r22
    tst  r22
    brne strcpy0
    movw r30,r24
    ret
_strlen:
	ST   -Y,R27
	ST   -Y,R26
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
	ST   -Y,R27
	ST   -Y,R26
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
_strncmpf:
	ST   -Y,R26
    clr  r0
    clr  r1
    ld   r22,y+
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
strncmpf0:
    tst  r22
    breq strncmpf1
    dec  r22
    ld   r1,x+
	lpm  r0,z+
    cp   r0,r1
    brne strncmpf1
    tst  r0
    brne strncmpf0
strncmpf3:
    clr  r30
    ret
strncmpf1:
    sub  r1,r0
    breq strncmpf3
    ldi  r30,1
    brcc strncmpf2
    subi r30,2
strncmpf2:
    ret
_strncpy:
	ST   -Y,R26
    ld   r23,y+
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strncpy0:
    tst  r23
    breq strncpy1
    dec  r23
    ld   r22,z+
    st   x+,r22
    tst  r22
    brne strncpy0
strncpy2:
    tst  r23
    breq strncpy1
    dec  r23
    st   x+,r22
    rjmp strncpy2
strncpy1:
    movw r30,r24
    ret

	.CSEG

	.DSEG
_Enc28j60Bank_G000:
	.BYTE 0x1
_NextPacketPtr_G000:
	.BYTE 0x2
_eth_buf:
	.BYTE 0x401
_wwwport_G000:
	.BYTE 0x2
_udpport_G000:
	.BYTE 0x2
_macaddr_G000:
	.BYTE 0x6
_ipaddr_G000:
	.BYTE 0x4
_info_hdr_len_G000:
	.BYTE 0x2
_info_data_len_G000:
	.BYTE 0x2
_seqnum_G000:
	.BYTE 0x1
_mymac:
	.BYTE 0x6
_myip:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	CALL _enc28j60WriteOp
	LDI  R30,LOW(128)
	ST   -Y,R30
	LDI  R30,LOW(31)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1:
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2:
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _enc28j60Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	ST   -Y,R30
	LDI  R26,LOW(25)
	JMP  _enc28j60Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	ST   -Y,R30
	LDI  R26,LOW(255)
	JMP  _enc28j60Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	ST   -Y,R30
	LDI  R30,LOW(31)
	ST   -Y,R30
	LDI  R26,LOW(8)
	JMP  _enc28j60WriteOp

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	ST   -Y,R30
	LDS  R30,_NextPacketPtr_G000+1
	MOV  R26,R30
	JMP  _enc28j60Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(58)
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _enc28j60ReadOp

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	STS  _NextPacketPtr_G000,R30
	STS  _NextPacketPtr_G000+1,R31
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA:
	CALL __GETD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xB:
	CALL __PUTD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xC:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	SBIW R30,8
	CALL __GETD2S0
	CLR  R22
	CLR  R23
	CALL __ADDD12
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xD:
	CALL __GETD2S0
	CALL __ADDD12
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xE:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	LDI  R17,0
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0xF:
	MOV  R30,R17
	LDI  R31,0
	MOVW R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x10:
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	MOVW R30,R0
	SUBI R30,LOW(-_ipaddr_G000)
	SBCI R31,HIGH(-_ipaddr_G000)
	LD   R30,Z
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	LDI  R17,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x12:
	MOV  R30,R17
	LDI  R31,0
	MOVW R22,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x13:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R30,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x14:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x15:
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x16:
	MOVW R30,R0
	SUBI R30,LOW(-_macaddr_G000)
	SBCI R31,HIGH(-_macaddr_G000)
	LD   R30,Z
	ST   X,R30
	SUBI R17,-1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x17:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x18:
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x19:
	CALL _checksum
	MOVW R16,R30
	MOV  R30,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1A:
	MOVW R30,R0
	SUBI R30,LOW(-_ipaddr_G000)
	SBCI R31,HIGH(-_ipaddr_G000)
	LD   R30,Z
	ST   X,R30
	SUBI R17,-1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1B:
	MOV  R30,R17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	ADIW R30,38
	SBIW R30,1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	ADIW R30,42
	SBIW R30,1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	CALL _make_eth
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1F:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(2)
	RJMP SUBOPT_0x19

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x20:
	__PUTB1SNS 2,50
	MOV  R30,R16
	__PUTB1SNS 2,51
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x21:
	STS  _info_data_len_G000,R30
	STS  _info_data_len_G000+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x22:
	LDS  R30,_info_data_len_G000
	LDS  R31,_info_data_len_G000+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x23:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	ADIW R30,1
	STD  Y+3,R30
	STD  Y+3+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x24:
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	SUBI R17,-1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x25:
	LDI  R30,LOW(_eth_buf)
	LDI  R31,HIGH(_eth_buf)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	ANDI R31,HIGH(0x0)
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x27:
	ANDI R31,HIGH(0xFF)
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x28:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x29:
	__GETW1SX 159
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x2A:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(10)
	CALL _strncmpf
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:77 WORDS
SUBOPT_0x2B:
	__GETW1SX 157
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:46 WORDS
SUBOPT_0x2C:
	CALL _concatstrf
	MOVW R16,R30
	RCALL SUBOPT_0x2B
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x2D:
	CALL _strcpy
	RCALL SUBOPT_0x2B
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x2E:
	RCALL SUBOPT_0x2B
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2F:
	CALL _concatstr
	MOVW R16,R30
	RJMP SUBOPT_0x2E

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x30:
	ST   -Y,R18
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x31:
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	SBIW R30,4
	STD  Y+21,R30
	STD  Y+21+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x32:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x33:
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x34:
	__PUTD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x35:
	__GETD1S 8
	__GETD2S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x36:
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ORD12:
	OR   R30,R26
	OR   R31,R27
	OR   R22,R24
	OR   R23,R25
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__ASRW4:
	ASR  R31
	ROR  R30
__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__LSRD16:
	MOV  R30,R22
	MOV  R31,R23
	LDI  R22,0
	LDI  R23,0
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
