#include <mega32a.h>
#include <stdio.h>
#include <string.h>
#include <delay.h>

//--------------------------------------
#define ENC28J60_SPI_PORT       PORTB
#define ENC28J60_SPI_DDR        DDRB
#define ENC28J60_SPI_MISO       6
#define ENC28J60_SPI_MOSI       5
#define ENC28J60_SPI_SCK        7
#define ENC28J60_SPI_CS         4
// ethernet buffer size
#define BUFFER_SIZE             1024
#include "ethernet.h"
//--------------------------------------
#define Relay1 PORTA.0
#define Relay2 PORTA.1
#define LED    PORTA.2 



//--------------------------------------
unsigned char   mymac[6] = {0x11,0x22,0x33,0x44,0x55,0x66};     // MAC
unsigned char   myip[4] = {192,168,2,10};                       // IP
unsigned char   time_cs = 0;            // 1/100 second counter
unsigned int    time_s = 0;             // seconds counter
//unsigned int    counter1 = 0;           // button 1 clicks
//unsigned int    counter2 = 0;           // button 2 clicks
//--------------------------------------
interrupt [TIM1_OVF] void timer1_ovf_isr(void)  // Timer 1 overflow ISR
{

        static bit old_btn1 = 0, old_btn2 = 0;
        if (++time_cs==100)             // one second elapsed
        {
                time_cs = 0;
                time_s ++;   
                #asm("wdr");
        }
        
}
//--------------------------------------
void main(void)
{
        uint8_t str[20]="";     // buffer to
        char t_lcd_buffer_1[10],t_lcd_buffer_2[10];
   // Watchdog Timer Enabled with Prescaler: OSC/512k
      WDTCR=0x0D;

        DDRA=(1<<0)|(1<<1)|(1<<2);
      
        // Timer 1 interrupts every 10 ms
        TCCR1A=0x02;
        TCCR1B=0x19;
        ICR1H=0xF4;
        ICR1L=0x23;
        // Timer(s) Interrupt(s) initialization
        TIMSK=0x04;
        // Analog Comparator: Off
        ACSR=0x80;                    
        
         
        
        
        #asm("wdr");

        // initialize ethernet
        ethernet_init(mymac, myip, 80, 1200);
        
          
       
        // Global enable interrupts
        #asm("sei")  
        #asm("wdr");
      
       
        while (1)
        {
                #asm("wdr");
               ethernet_process(); //process ethernet transactions
               delay_ms(100); 
              
        }
}
//--------------------------------------
unsigned char ethernet_udp(unsigned char* data, unsigned char data_len)
{
        unsigned char str[20];      
        strncpy(str, data, 11);
        sprintf(str, "UTP is Working \n");
        data_len = concatstr(data, 0, str);
        time_cs = 0;
        time_s = 0;
        return data_len;
}
//--------------------------------------
unsigned int ethernet_tcp(unsigned char* request, unsigned char* response)
{
        unsigned int len;                
        unsigned char str[20],ledstatus[43],r1status[46],r2status[46];
        if (strncmpf(request, "GET /", 5)!=0)
                return 0;      
          // relays if    
          
          
          strncpy(str,request,10);
          if (strncmpf(request, "GET /?l1=1", 10)==0)   
          {
           LED=1;
                     
           
            }
           if (strncmpf(request, "GET /?l1=0", 10)==0)
            {
           LED=0;
                      
            }  
           
          if (strncmpf(request, "GET /?R1=1", 10)==0)
          {
           Relay1=1;   
           
           }  
           
           if (strncmpf(request, "GET /?R1=0", 10)==0)
          {
           Relay1=0;   
           
           } 
           
          if (strncmpf(request, "GET /?R2=1", 10)==0)
           {
           Relay2=1;   
          
           }
           if (strncmpf(request, "GET /?R2=0", 10)==0)
           {
           Relay2=0;   
           
           }
           
           
         //end realy       

        len = concatstrf(response, 0, "HTTP/1.0 200 OK\r\n");
        len = concatstrf(response, len, "Content-Type: text/html\r\n");
        len = concatstrf(response, len, "Pragma: no-cache\r\n\r\n");
        len = concatstrf(response, len,
                "<HTML><Ethernet Relay Controller 2Ch  </TITLE><BODY><CENTER>");
        len = concatstrf(response, len,
                "<P> Melec.ir  </P>\n<HR>");
           
            
          len = concatstrf(response, len,"<P> <FONT COLOR=#0000FF> ");     
               
                if(LED==1){
           strcpy(ledstatus,"<P> <FONT COLOR=#44ad39>LED=ON</FONT></P>"); 
           len = concatstrf(response, len,
                 "<A HREF=\"./?l1=0\">Turn OFF LED</A>");
            }
           else{
           strcpy(ledstatus,"<P> <FONT COLOR=#44ad39>LED=OFF</FONT></P>");  
            len = concatstrf(response, len,
                "<A HREF=\"./?l1=1\">Turn ON LED</A>");       
            }    
             len = concatstr(response, len, ledstatus);
           len = concatstrf(response, len, "<HR></FONT></P>");
           
                      
           
           
           
            len = concatstrf(response, len,"<P>");     
                  
                  if(Relay1==1) {
           strcpy(r1status,"<P> <FONT COLOR=#44ad39>Relay1=ON</FONT></P>"); 
            len = concatstrf(response, len,
                "<A HREF=\"./?R1=0\">Turn OFF Relay1</A>");    
            }
           else          {
            strcpy(r1status,"<P> <FONT COLOR=#44ad39>Relay1=OFF</FONT></P>");  
            len = concatstrf(response, len,
                "<A HREF=\"./?R1=1\">Turn ON Relay1</A>");
                 }  
                 len = concatstr(response, len, r1status);
           len = concatstrf(response, len, "<HR>");     
           
           
           
           
             len = concatstrf(response, len,"<P> <FONT COLOR=#0000FF> ");   
               
             
                 if(Relay2==1)  {
             strcpy(r2status,"<P> <FONT COLOR=#44ad39>Relay2=ON</FONT></P>"); 
                len = concatstrf(response, len,
                "<A HREF=\"./?R2=0\">Turn OFF Relay2</A>");   
                
             }
           else  {
           strcpy(r2status,"<P> <FONT COLOR=#44ad39>Relay2=OFF</FONT></P>");  
               len = concatstrf(response, len,
                "<A HREF=\"./?R2=1\">Turn ON Relay2</A>");
                   
           }
            len = concatstr(response, len, r2status); 
           len = concatstrf(response, len, "<HR> </FONT></P>");   
           
//            len = concatstrf(response, len,"<P> <FONT COLOR=#0000FF> ");     
//            len = concatstr(response, len, str); 
//           len = concatstrf(response, len, "</FONT></P>");     
                 
        
         
        

        
        
        len = concatstrf(response, len,
                "<P><A HREF=\".\">refresh</A></P></CENTER><HR>\n");    
                     
           
           
                    
               
               
                
                
             
                    
                                
                
        time_cs = 0;
        time_s = 0;
        return len;
}
