
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADCSR=6;     
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned char strlcpy(char *dest,char *src,unsigned char n);	
unsigned char strlcpyf(char *dest,char flash *src,unsigned char n); 
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

void ethernet_init(unsigned char *dev_mac, unsigned char *dev_ip, unsigned int port_tcp, unsigned int port_udp);
void ethernet_process();
unsigned int ethernet_tcp(unsigned char* request, unsigned char* response);
unsigned char ethernet_udp(unsigned char* data, unsigned char data_len);
unsigned int concatstr(char *buf, unsigned int pos, const char *s);
unsigned int concatstrf(char *buf, unsigned int pos, const flash char *s);

typedef unsigned char   uint8_t;
typedef   signed char   int8_t;
typedef unsigned short  uint16_t;
typedef   signed short  int16_t;
typedef unsigned long   uint32_t;
typedef   signed long	int32_t;

#pragma used+

uint8_t enc28j60ReadOp(uint8_t op, uint8_t address);
void    enc28j60WriteOp(uint8_t op, uint8_t address, uint8_t data);
void    enc28j60ReadBuffer(uint16_t len, uint8_t* data);
void    enc28j60WriteBuffer(uint16_t len, uint8_t* data);
void    enc28j60SetBank(uint8_t address);
uint8_t enc28j60Read(uint8_t address);
void    enc28j60Write(uint8_t address, uint8_t data);
void    enc28j60PhyWrite(uint8_t address, uint16_t data);
void    enc28j60clkout(uint8_t clk);
void    enc28j60Init(uint8_t* macaddr);
void    enc28j60PacketSend(uint16_t len, uint8_t* packet);
uint16_t enc28j60PacketReceive(uint16_t maxlen, uint8_t* packet);
uint8_t enc28j60getrev(void);
uint8_t enc28j60linkup(void);

uint8_t eth_type_is_arp_and_my_ip(uint8_t *buf,uint16_t len);
uint8_t eth_type_is_ip_and_my_ip(uint8_t *buf,uint16_t len);
void make_arp_answer_from_request(uint8_t *buf);
void make_echo_reply_from_request(uint8_t *buf,uint16_t len);
void make_udp_reply_from_request(uint8_t *buf, uint8_t datalen);
void make_tcp_synack_from_syn(uint8_t *buf);
uint16_t get_tcp_data_pointer(uint8_t *buf);
void make_tcp_ack_from_any(uint8_t *buf);
void make_tcp_ack_with_data(uint8_t *buf,uint16_t dlen);

static uint8_t Enc28j60Bank;
static uint16_t NextPacketPtr;

uint8_t enc28j60ReadOp(uint8_t op, uint8_t address)
{
PORTB&=~(1<<4);

SPDR = op | (address & 0x1F);
while(!(SPSR&(1<<7)));

SPDR = 0x00;
while(!(SPSR&(1<<7)));

if(address & 0x80)
{
SPDR = 0x00;
while(!(SPSR&(1<<7)));
}

PORTB|=(1<<4);
return(SPDR);
}

void enc28j60WriteOp(uint8_t op, uint8_t address, uint8_t data)
{
PORTB&=~(1<<4);

SPDR = op | (address & 0x1F);
while(!(SPSR&(1<<7)));

SPDR = data;
while(!(SPSR&(1<<7)));
PORTB|=(1<<4);
}

void enc28j60ReadBuffer(uint16_t len, uint8_t* data)
{
PORTB&=~(1<<4);

SPDR = 0x3A;
while(!(SPSR&(1<<7)));
while(len)
{
len--;

SPDR = 0x00;
while(!(SPSR&(1<<7)));
*data = SPDR;
data++;
}
*data='\0';
PORTB|=(1<<4);
}

void enc28j60WriteBuffer(uint16_t len, uint8_t* data)
{
PORTB&=~(1<<4);

SPDR = 0x7A;
while(!(SPSR&(1<<7)));
while(len)
{
len--;

SPDR = *data;
data++;
while(!(SPSR&(1<<7)));
}
PORTB|=(1<<4);
}

void enc28j60SetBank(uint8_t address)
{

if((address & 0x60) != Enc28j60Bank)
{

enc28j60WriteOp(0xA0, 0x1F, (0x02|0x01));
enc28j60WriteOp(0x80, 0x1F, (address & 0x60)>>5);
Enc28j60Bank = (address & 0x60);
}
}

uint8_t enc28j60Read(uint8_t address)
{

enc28j60SetBank(address);

return enc28j60ReadOp(0x00, address);
}

uint16_t enc28j60PhyReadH(uint8_t address)
{

enc28j60Write((0x14|0x40|0x80), address);
enc28j60Write((0x12|0x40|0x80), 0x01);
delay_us(15);

while(enc28j60Read((0x0A|0x60|0x80)) & 0x01);

enc28j60Write((0x12|0x40|0x80), 0x00);

return (enc28j60Read((0x19|0x40|0x80)));
}

void enc28j60Write(uint8_t address, uint8_t data)
{

enc28j60SetBank(address);

enc28j60WriteOp(0x40, address, data);
}

void enc28j60PhyWrite(uint8_t address, uint16_t data)
{

enc28j60Write((0x14|0x40|0x80), address);

enc28j60Write((0x16|0x40|0x80), data);
enc28j60Write((0x17|0x40|0x80), data>>8);

while(enc28j60Read((0x0A|0x60|0x80)) & 0x01){
delay_us(15);
}
}

void enc28j60clkout(uint8_t clk)
{

enc28j60Write((0x15|0x60), clk & 0x7);
}

void enc28j60Init(uint8_t* macaddr)
{

DDRB &= ~(1<<6);
DDRB |= (1<<5) | (1<<7) | (1<<4);
PORTB &= ~((1<<5) | (1<<7));
PORTB |= (1<<4);

SPCR = (1<<6)|(1<<4);
SPSR |= (1<<0);

enc28j60WriteOp(0xFF, 0, 0xFF);
delay_ms(50);

NextPacketPtr = 0x0;

enc28j60Write((0x08|0x00), 0x0&0xFF);
enc28j60Write((0x09|0x00), 0x0>>8);

enc28j60Write((0x0C|0x00), 0x0&0xFF);
enc28j60Write((0x0D|0x00), 0x0>>8);

enc28j60Write((0x0A|0x00), (0x1FFF-0x0600-1)&0xFF);
enc28j60Write((0x0B|0x00), (0x1FFF-0x0600-1)>>8);

enc28j60Write((0x04|0x00), (0x1FFF-0x0600)&0xFF);
enc28j60Write((0x05|0x00), (0x1FFF-0x0600)>>8);

enc28j60Write((0x06|0x00), 0x1FFF&0xFF);
enc28j60Write((0x07|0x00), 0x1FFF>>8);

enc28j60Write((0x18|0x20), 0x80|0x20|0x10);
enc28j60Write((0x08|0x20), 0x3f);
enc28j60Write((0x09|0x20), 0x30);
enc28j60Write((0x10|0x20), 0xf9);
enc28j60Write((0x11|0x20), 0xf7);

enc28j60Write((0x00|0x40|0x80), 0x01|0x08|0x04);

enc28j60Write((0x01|0x40|0x80), 0x00);

enc28j60WriteOp(0x80, (0x02|0x40|0x80), 0x20|0x10|0x02);

enc28j60Write((0x06|0x40|0x80), 0x12);
enc28j60Write((0x07|0x40|0x80), 0x0C);

enc28j60Write((0x04|0x40|0x80), 0x12);

enc28j60Write((0x0A|0x40|0x80), 1500        &0xFF);
enc28j60Write((0x0B|0x40|0x80), 1500        >>8);

enc28j60Write((0x04|0x60|0x80), macaddr[0]);
enc28j60Write((0x05|0x60|0x80), macaddr[1]);
enc28j60Write((0x02|0x60|0x80), macaddr[2]);
enc28j60Write((0x03|0x60|0x80), macaddr[3]);
enc28j60Write((0x00|0x60|0x80), macaddr[4]);
enc28j60Write((0x01|0x60|0x80), macaddr[5]);

enc28j60PhyWrite(0x10, 0x0100);

enc28j60SetBank(0x1F);

enc28j60WriteOp(0x80, 0x1B, 0x80|0x40);

enc28j60WriteOp(0x80, 0x1F, 0x04);

enc28j60PhyWrite(0x14,0x0476);
delay_ms(20);
}

uint8_t enc28j60getrev(void)
{
return(enc28j60Read((0x12|0x60)));
}

uint8_t enc28j60linkup(void)
{

return(enc28j60PhyReadH(0x11) && 4);
}

void enc28j60PacketSend(uint16_t len, uint8_t* packet)
{

enc28j60Write((0x02|0x00), (0x1FFF-0x0600)&0xFF);
enc28j60Write((0x03|0x00), (0x1FFF-0x0600)>>8);

enc28j60Write((0x06|0x00), ((0x1FFF-0x0600)+len)&0xFF);
enc28j60Write((0x07|0x00), ((0x1FFF-0x0600)+len)>>8);

enc28j60WriteOp(0x7A, 0, 0x00);

enc28j60WriteBuffer(len, packet);

enc28j60WriteOp(0x80, 0x1F, 0x08);

if( (enc28j60Read(0x1C) & 0x02) ){
enc28j60WriteOp(0xA0, 0x1F, 0x08);
}
}

uint16_t enc28j60PacketReceive(uint16_t maxlen, uint8_t* packet)
{
uint16_t rxstat;
uint16_t len;

if( enc28j60Read((0x19|0x20)) ==0 ){
return(0);
}

enc28j60Write((0x00|0x00), (NextPacketPtr));
enc28j60Write((0x01|0x00), (NextPacketPtr)>>8);

NextPacketPtr  = enc28j60ReadOp(0x3A, 0);
NextPacketPtr |= enc28j60ReadOp(0x3A, 0)<<8;

len  = enc28j60ReadOp(0x3A, 0);
len |= enc28j60ReadOp(0x3A, 0)<<8;
len-=4; 

rxstat  = enc28j60ReadOp(0x3A, 0);
rxstat |= ((uint16_t)enc28j60ReadOp(0x3A, 0))<<8;

if (len>maxlen-1){
len=maxlen-1;
}

if ((rxstat & 0x80)==0){

len=0;
}else{

enc28j60ReadBuffer(len, packet);
}

enc28j60Write((0x0C|0x00), (NextPacketPtr));
enc28j60Write((0x0D|0x00), (NextPacketPtr)>>8);

enc28j60WriteOp(0x80, 0x1E, 0x40);
return(len);
}

unsigned char eth_buf[1024+1];
static uint16_t wwwport=80;
static uint16_t udpport=1200;
static uint8_t macaddr[6];
static uint8_t ipaddr[4];
static int16_t info_hdr_len=0;
static int16_t info_data_len=0;
static uint8_t seqnum=0xa; 

uint16_t checksum(uint8_t *buf, uint16_t len,uint8_t type){

uint32_t sum = 0;

if(type==1){
sum+=17; 

sum+=len-8; 
}
if(type==2){
sum+=6;

sum+=len-8; 
}

while(len >1){
sum += 0xFFFF & (((uint32_t)*buf<<8)|*(buf+1));
buf+=2;
len-=2;
}

if (len){
sum += ((uint32_t)(0xFF & *buf))<<8;
}

while (sum>>16){
sum = (sum & 0xFFFF)+(sum >> 16);
}

return( (uint16_t) sum ^ 0xFFFF);
}

uint8_t eth_type_is_arp_and_my_ip(uint8_t *buf,uint16_t len){
uint8_t i=0;

if (len<41){
return(0);
}
if(buf[12] != 0x08 ||
buf[13] != 0x06){
return(0);
}
while(i<4){
if(buf[0x26+i] != ipaddr[i]){
return(0);
}
i++;
}
return(1);
}

uint8_t eth_type_is_ip_and_my_ip(uint8_t *buf,uint16_t len){
uint8_t i=0;

if (len<42){
return(0);
}
if(buf[12]!=0x08 ||
buf[13]!=0x00){
return(0);
}
if (buf[0xe]!=0x45){

return(0);
}
while(i<4){
if(buf[0x1e+i]!=ipaddr[i]){
return(0);
}
i++;
}
return(1);
}

void make_eth(uint8_t *buf)
{
uint8_t i=0;

while(i<6){
buf[0 +i]=buf[6 +i];
buf[6 +i]=macaddr[i];
i++;
}
}
void fill_ip_hdr_checksum(uint8_t *buf)
{
uint16_t ck;

buf[0x18]=0;
buf[0x18+1]=0;
buf[0x14]=0x40; 
buf[0x14+1]=0;  
buf[0x16]=64; 

ck=checksum(&buf[0xe], 20,0);
buf[0x18]=ck>>8;
buf[0x18+1]=ck& 0xff;
}

void make_ip(uint8_t *buf)
{
uint8_t i=0;
while(i<4){
buf[0x1e+i]=buf[0x1a+i];
buf[0x1a+i]=ipaddr[i];
i++;
}
fill_ip_hdr_checksum(buf);
}

void make_tcphead(uint8_t *buf,uint16_t rel_ack_num,uint8_t mss,uint8_t cp_seq)
{
uint8_t i=0;
uint8_t tseq;

buf[0x24] = buf[0x22];
buf[0x25] = buf[0x23];

buf[0x23] = ((wwwport)&0x00FF);
buf[0x22] = ((wwwport)>>8);
i=4;

while(i>0){
rel_ack_num=buf[0x26+i-1]+rel_ack_num;
tseq=buf[0x2a+i-1];
buf[0x2a+i-1]=0xff&rel_ack_num;
if (cp_seq){

buf[0x26+i-1]=tseq;
}else{
buf[0x26+i-1]= 0; 
}
rel_ack_num=rel_ack_num>>8;
i--;
}
if (cp_seq==0){

buf[0x26+0]= 0;
buf[0x26+1]= 0;

buf[0x26+2]= seqnum;
buf[0x26+3]= 0;

seqnum+=2;
}

buf[0x32]=0;
buf[0x33]=0;

if (mss){

buf[0x36]=2;
buf[0x36+1]=4;
buf[0x36+2]=0x05;
buf[0x36+3]=0x80;

buf[0x2e]=0x60;
}else{

buf[0x2e]=0x50;
}
}

void make_arp_answer_from_request(uint8_t *buf)
{
uint8_t i=0;

make_eth(buf);
buf[0x14]=0x0;
buf[0x15]=0x02;

while(i<6){
buf[0x20+i]=buf[0x16+i];
buf[0x16+i]=macaddr[i];
i++;
}
i=0;
while(i<4){
buf[0x26+i]=buf[0x1c+i];
buf[0x1c+i]=ipaddr[i];
i++;
}

enc28j60PacketSend(42,buf);
}

void make_echo_reply_from_request(uint8_t *buf,uint16_t len)
{
make_eth(buf);
make_ip(buf);
buf[0x22]=0;

if (buf[0x24] > (0xff-0x08)){
buf[0x24+1]++;
}
buf[0x24]+=0x08;

enc28j60PacketSend(len,buf);
}

void make_udp_reply_from_request(uint8_t *buf, uint8_t datalen)
{
uint8_t i=0;
uint16_t ck;
make_eth(buf);
if (datalen>220){
datalen=220;
}

buf[0x10]=0;
buf[0x11]=20+8+datalen;
make_ip(buf);

buf[0x24]=buf[0x22];
buf[0x25]= buf[0x23];
buf[0x22]=((udpport)>>8);
buf[0x23]=((udpport)&0x00FF);

buf[0x26]=0;
buf[0x27]=8+datalen;

buf[0x28]=0;
buf[0x29]=0;

ck=checksum(&buf[0x1a], 16 + datalen,1);
buf[0x28]=ck>>8;
buf[0x29]=ck& 0xff;
enc28j60PacketSend(8+20+14+datalen,buf);
}

void make_tcp_synack_from_syn(uint8_t *buf)
{
uint16_t ck;
make_eth(buf);

buf[0x10]=0;
buf[0x11]=20+20+4;
make_ip(buf);
buf[0x2f]=0x12;
make_tcphead(buf,1,1,0);

ck=checksum(&buf[0x1a], 8+20+4,2);
buf[0x32]=ck>>8;
buf[0x33]=ck& 0xff;

enc28j60PacketSend(20+20+4+14,buf);
}

uint16_t get_tcp_data_pointer(uint8_t *buf)
{
info_data_len=(((int16_t)buf[0x10])<<8)|(buf[0x11]&0xff);
info_data_len-=20;
info_hdr_len=(buf[0x2e]>>4)*4; 
info_data_len-=info_hdr_len;
if (info_data_len<=0){
info_data_len=0;
return(0);
}
return((uint16_t)0x22+info_hdr_len);
}

uint16_t concatstrf(uint8_t *buf, uint16_t pos, const flash char *s)
{
char c;
while ((c = *s++)!=0)
{
buf[pos]=c;
pos++;
}
return(pos);
}

uint16_t concatstr(uint8_t *buf, uint16_t pos, const char *s)
{
char c;
while ((c = *s++)!=0)
{
buf[pos]=c;
pos++;
}
return(pos);
}

void make_tcp_ack_from_any(uint8_t *buf)
{
uint16_t j;
make_eth(buf);

buf[0x2f]=0x10;
if (info_data_len==0){

make_tcphead(buf,1,0,1); 
}else{
make_tcphead(buf,info_data_len,0,1); 
}

j=20+20;
buf[0x10]=j>>8;
buf[0x11]=j& 0xff;
make_ip(buf);

j=checksum(&buf[0x1a], 8+20,2);
buf[0x32]=j>>8;
buf[0x33]=j& 0xff;
enc28j60PacketSend(20+20+14,buf);
}

void make_tcp_ack_with_data(uint8_t *buf,uint16_t dlen)
{
uint16_t j;

buf[0x2f]=0x10|0x08|0x01;

j=20+20+dlen;
buf[0x10]=j>>8;
buf[0x11]=j& 0xff;
fill_ip_hdr_checksum(buf);

buf[0x32]=0;
buf[0x33]=0;

j=checksum(&buf[0x1a], 8+20+dlen,2);
buf[0x32]=j>>8;
buf[0x33]=j& 0xff;
enc28j60PacketSend(20+20+dlen+14,buf);
}

void ethernet_init(unsigned char *dev_mac, unsigned char *dev_ip, unsigned int port_tcp, unsigned int port_udp)
{
uint8_t i=0;
wwwport=port_tcp;
udpport=port_udp;
while(i<4){
ipaddr[i]=dev_ip[i];
i++;
}
i=0;
while(i<6){
macaddr[i]=dev_mac[i];
i++;
}

enc28j60Init(dev_mac);
}

void ethernet_process()
{
uint16_t plen;
uint16_t data_p;
uint8_t data_len;

plen = enc28j60PacketReceive(1024, eth_buf);
if(plen!=0)
{

if(eth_type_is_arp_and_my_ip(eth_buf,plen))
{
make_arp_answer_from_request(eth_buf);
}

else if(eth_type_is_ip_and_my_ip(eth_buf,plen))
{
if( eth_buf[0x17]==1
&& eth_buf[0x22]==8 )
{

make_echo_reply_from_request(eth_buf,plen);
}

else if (eth_buf[0x17]==6
&&eth_buf[0x24]==((wwwport)>>8)
&&eth_buf[0x25]==((wwwport)&0x00FF) )
{
if (eth_buf[0x2f] & 0x02)

make_tcp_synack_from_syn(eth_buf);
else if (eth_buf[0x2f] & 0x10)
{

data_p=get_tcp_data_pointer(eth_buf);
if (data_p==0)
{

if (eth_buf[0x2f] & 0x01)
{

make_tcp_ack_from_any(eth_buf);
}
}
else
{
plen = ethernet_tcp( eth_buf+data_p, eth_buf+0x33+3 );
make_tcp_ack_from_any(eth_buf); 
make_tcp_ack_with_data(eth_buf, plen); 
}
}
}

else if (eth_buf[0x17]==17
&&eth_buf[0x24]==((udpport)>>8)
&&eth_buf[0x25]==((udpport)&0x00FF) )
{
data_len = eth_buf[0x27]-8;
data_len = ethernet_udp( eth_buf+0x2a, data_len);
make_udp_reply_from_request(eth_buf, data_len);
}
}
}
}

#pragma used-

unsigned char   mymac[6] = {0x11,0x22,0x33,0x44,0x55,0x66};     
unsigned char   myip[4] = {192,168,2,10};                       
unsigned char   time_cs = 0;            
unsigned int    time_s = 0;             

interrupt [10] void timer1_ovf_isr(void)  
{

static bit old_btn1 = 0, old_btn2 = 0;
if (++time_cs==100)             
{
time_cs = 0;
time_s ++;   
#asm("wdr");
}

}

void main(void)
{
uint8_t str[20]="";     
char t_lcd_buffer_1[10],t_lcd_buffer_2[10];

WDTCR=0x0D;

DDRA=(1<<0)|(1<<1)|(1<<2);

TCCR1A=0x02;
TCCR1B=0x19;
ICR1H=0xF4;
ICR1L=0x23;

TIMSK=0x04;

ACSR=0x80;                    

#asm("wdr");

ethernet_init(mymac, myip, 80, 1200);

#asm("sei")  
#asm("wdr");

while (1)
{
#asm("wdr");
ethernet_process(); 
delay_ms(100); 

}
}

unsigned char ethernet_udp(unsigned char* data, unsigned char data_len)
{
unsigned char str[20];      
strncpy(str, data, 11);
sprintf(str, "UTP is Working \n");
data_len = concatstr(data, 0, str);
time_cs = 0;
time_s = 0;
return data_len;
}

unsigned int ethernet_tcp(unsigned char* request, unsigned char* response)
{
unsigned int len;                
unsigned char str[20],ledstatus[43],r1status[46],r2status[46];
if (strncmpf(request, "GET /", 5)!=0)
return 0;      

strncpy(str,request,10);
if (strncmpf(request, "GET /?l1=1", 10)==0)   
{
PORTA.2 =1;

}
if (strncmpf(request, "GET /?l1=0", 10)==0)
{
PORTA.2 =0;

}  

if (strncmpf(request, "GET /?R1=1", 10)==0)
{
PORTA.0=1;   

}  

if (strncmpf(request, "GET /?R1=0", 10)==0)
{
PORTA.0=0;   

} 

if (strncmpf(request, "GET /?R2=1", 10)==0)
{
PORTA.1=1;   

}
if (strncmpf(request, "GET /?R2=0", 10)==0)
{
PORTA.1=0;   

}

len = concatstrf(response, 0, "HTTP/1.0 200 OK\r\n");
len = concatstrf(response, len, "Content-Type: text/html\r\n");
len = concatstrf(response, len, "Pragma: no-cache\r\n\r\n");
len = concatstrf(response, len,
"<HTML><Ethernet Relay Controller 2Ch  </TITLE><BODY><CENTER>");
len = concatstrf(response, len,
"<P> Melec.ir  </P>\n<HR>");

len = concatstrf(response, len,"<P> <FONT COLOR=#0000FF> ");     

if(PORTA.2 ==1){
strcpy(ledstatus,"<P> <FONT COLOR=#44ad39>LED=ON</FONT></P>"); 
len = concatstrf(response, len,
"<A HREF=\"./?l1=0\">Turn OFF LED</A>");
}
else{
strcpy(ledstatus,"<P> <FONT COLOR=#44ad39>LED=OFF</FONT></P>");  
len = concatstrf(response, len,
"<A HREF=\"./?l1=1\">Turn ON LED</A>");       
}    
len = concatstr(response, len, ledstatus);
len = concatstrf(response, len, "<HR></FONT></P>");

len = concatstrf(response, len,"<P>");     

if(PORTA.0==1) {
strcpy(r1status,"<P> <FONT COLOR=#44ad39>Relay1=ON</FONT></P>"); 
len = concatstrf(response, len,
"<A HREF=\"./?R1=0\">Turn OFF Relay1</A>");    
}
else          {
strcpy(r1status,"<P> <FONT COLOR=#44ad39>Relay1=OFF</FONT></P>");  
len = concatstrf(response, len,
"<A HREF=\"./?R1=1\">Turn ON Relay1</A>");
}  
len = concatstr(response, len, r1status);
len = concatstrf(response, len, "<HR>");     

len = concatstrf(response, len,"<P> <FONT COLOR=#0000FF> ");   

if(PORTA.1==1)  {
strcpy(r2status,"<P> <FONT COLOR=#44ad39>Relay2=ON</FONT></P>"); 
len = concatstrf(response, len,
"<A HREF=\"./?R2=0\">Turn OFF Relay2</A>");   

}
else  {
strcpy(r2status,"<P> <FONT COLOR=#44ad39>Relay2=OFF</FONT></P>");  
len = concatstrf(response, len,
"<A HREF=\"./?R2=1\">Turn ON Relay2</A>");

}
len = concatstr(response, len, r2status); 
len = concatstrf(response, len, "<HR> </FONT></P>");   

len = concatstrf(response, len,
"<P><A HREF=\".\">refresh</A></P></CENTER><HR>\n");    

time_cs = 0;
time_s = 0;
return len;
}
